/**
 * This class contain the algorithm implementation for line/line topological predicates
 * \author Reasey Praing
 * \version 0.1
 * \version 0.2
 * \date	2006-11-08
 * \note for mslob
 */

#ifndef ALGORITHM_LL_H
#define ALGORITHM_LL_H

#include <iostream>
#include "line2D.h"
//#include "region2D.h"
#include "poi2D.h"
#include "hseg2D.h"
#include "statusHseg2D.h"
#include "EventSchedule.h"
#include "SweepLine.h"
#include "MatchPred.h"
#include "dvector.h"

namespace stu
{
using namespace stu;

class Algorithm_ll
{
private:
	bool *vf, *vg;
	int m, n;
public:
	bool debug;
	Algorithm_ll() : m(6), n(3)
	{
		debug = false;
	}
	Algorithm_ll(bool dg) : debug(dg)
	{
		m = 6;
		n = 3;
	}

	int topPred(line2D& l1, line2D& l2, int verify)  //verify = -1 for determination; >0 for verification; return id for determination and true answer; return -1 for false answer
	{
		debug = false;
		whichObj object;
		whatStatus status;
		initializeFlags();
		dvector<hseg2D> dyn1;
		dvector<hseg2D> dyn2;
		EventSchedule<line2D, line2D, hseg2D, hseg2D> es(l1, l2,dyn1,dyn2);
		//***********Begin Algorithm************

		//Create sweepline object
		SweepLine<line2D, line2D, hseg2D, hseg2D> S;
		poi2D last_dp_in_F, last_dp_in_G, last_bound_in_F, last_bound_in_G;
		es.select_first(object, status);
		statusHseg2D sh;
		bool db = false;
		while(status != end_of_both && !allTrue()) //----------------> Need to change in paper (since need to check boundary point)
		{
//			cout<<"run: \n";
			if(object == first)
			{
				if(db) cout<<"First: {"<<es.i1->getDominating()<<", "<<es.i1->getSubmissive()<<") , "<<es.i1->isLeft()<<"}"<<endl;
				sh = statusHseg2D(*(es.i1), 'F');
				if(es.i1->isLeft())
				{
					if(db) cout<<"(Add event:" << es.i1->getDominating().getX() << "-"<< es.i1->getSubmissive().getX() << ") \n";
					S.add_left(sh, es);
				}
				else
				{
//					cout<<" vf2 \n";
					if(db) cout<<"(Del event:" << es.i1->getDominating().getX() << "-"<< es.i1->getSubmissive().getX() << ") \n";
					S.del_right(sh, es);
					vf[2] = true;  if(debug) cout<<"1 ";           //>>>>>>>>>>>>>>>>>>>>>>>..modded
				}
				if(last_dp_in_F.isUndefined()||(!last_dp_in_F.isUndefined() && sh.hseg->getDominating() != last_dp_in_F))
				{
					last_dp_in_F = sh.hseg->getDominating();
					if(!es.look_aheadF(es.i1))
					{
//						cout<<" vf435 \n";
						last_bound_in_F = sh.hseg->getDominating();
						if(db) cout<<"last_bound_in_F:" << last_bound_in_F.getX() << ","<< last_bound_in_F.getY() << ") \n";
						if(!last_bound_in_G.isUndefined() && last_bound_in_F == last_bound_in_G)
						{	vf[4] = true; if(debug) cout<<"2 ";}
						else if((!last_dp_in_G.isUndefined() && last_bound_in_F == last_dp_in_G) || S.poi_in_seg(last_bound_in_F, 'F')) //ADDED
						{	vf[3] = true; if(debug) cout<<"3 ";}
						else if(!es.look_aheadG(es.i1))
						{
							if(db) cout<<"look_aheadG(es.i1): " << es.look_aheadF(es.i2) <<endl;
							vf[5]= true; if(debug) cout<<"4 ";
							vf[2]=true;  if(debug) cout<<"5 ";//ADDED
						}
					}
					else //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>added 6/14/06 to handle the reverse of direction of the meeting point problem
					{
						if(!last_bound_in_G.isUndefined() && last_dp_in_F == last_bound_in_G)
						{	vg[1] = true; if(debug) cout<<"6 ";}
						else if(!last_dp_in_G.isUndefined() && last_dp_in_F == last_dp_in_G)
						{	vf[1] = true; if(debug) cout<<"7 ";}
						else if(!es.look_aheadG(es.i1))
						{
							if(db) cout<<"look_aheadG(es.i1): " << es.look_aheadG(es.i1) <<endl;
							vf[2]=true; if(debug) cout<<"8 ";
						}
					}
				}
				if(!last_bound_in_F.isUndefined() && sh.hseg->getDominating() != last_bound_in_F)  //>>>>>>>>>>>removed 6/14/06 (incorrect)>>>>>>>>>>>>>>
				{
//					cout<<" vg1f1 \n";
					if(!last_bound_in_G.isUndefined() && sh.hseg->getDominating() == last_bound_in_G)
					{	vg[1] = true; if(debug) cout<<"8a ";}
					else if(!last_dp_in_G.isUndefined() && sh.hseg->getDominating() == last_dp_in_G)
					{	vf[1] = true; if(debug) cout<<"8b ";}
				}

			}
			else if(object == second)
			{
				if(db) cout<<"Second: {"<<es.i2->getDominating()<<", "<<es.i2->getSubmissive()<<") , "<<es.i2->isLeft()<<"}"<<endl;
				sh = statusHseg2D(*(es.i2), 'G');
				if(sh.hseg->isLeft())
				{
					if(db) cout<<"(Add event:" << es.i2->getDominating().getX() << "-"<< es.i2->getSubmissive().getX() << ") \n";
					S.add_left(sh, es);
				}
				else
				{
//					cout<<" vg0 \n";
					if(db) cout<<"(Del event:" << es.i2->getDominating().getX() << "-"<< es.i2->getSubmissive().getX() << ") \n";
					S.del_right(sh, es);
					vg[0] = true; if(debug) cout<<"9 ";
				}
				if(last_dp_in_G.isUndefined()||(!last_dp_in_G.isUndefined() && sh.hseg->getDominating() != last_dp_in_G))
				{
					last_dp_in_G = sh.hseg->getDominating();
					if(!es.look_aheadG(es.i2))
					{	//is boundary point
//						cout<<" vf4g12 \n";
						last_bound_in_G = sh.hseg->getDominating();
						if(db) cout<<"last_bound_in_G:" << last_bound_in_G.getX() << ","<< last_bound_in_G.getY() << ") \n";
						if(!last_bound_in_F.isUndefined() && last_bound_in_G == last_bound_in_F)
						{	vf[4] = true; if(debug) cout<<"10 ";}
						else if((!last_dp_in_F.isUndefined() && last_bound_in_G == last_dp_in_F) || S.poi_in_seg(last_bound_in_G, 'G')) //ADDED
						{	vg[1] = true; if(debug) cout<<"11 ";}
						else if(!es.look_aheadF(es.i2))
						{
							if(db) cout<<"look_aheadF(es.i2): " << es.look_aheadF(es.i2) <<endl;
							vg[2]= true; if(debug) cout<<"12 ";
							vg[0]=true;  if(debug) cout<<"13 ";//ADDED
						}
					}
					else //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>added 6/14/06 to handle the reverse of direction of the meeting point problem
					{
						if(!last_bound_in_F.isUndefined() && last_dp_in_G == last_bound_in_F)
						{	vf[3] = true; if(debug) cout<<"14 ";}
						else if(!last_dp_in_F.isUndefined() && last_dp_in_G == last_dp_in_F)
						{	vf[1] = true; if(debug) cout<<"15 ";}
						else if(!es.look_aheadF(es.i1))
						{
							if(db) cout<<"look_aheadF(es.i2): " << es.look_aheadF(es.i2) <<endl;
							vg[0]=true; if(debug) cout<<"16 ";
						}
					}
				}
				if(!last_bound_in_G.isUndefined() && sh.hseg->getDominating() != last_bound_in_G)         //>>>>>>>>>>>removed 6/14/06 (incorrect) >>>>>>>>>>>>>>
				{
//					cout<<"vf31\n";
					if(!last_bound_in_F.isUndefined() && sh.hseg->getDominating() == last_bound_in_F)
					{	vf[3] = true; if(debug) cout<<"16a ";}
					else if(!last_dp_in_F.isUndefined() && sh.hseg->getDominating() == last_dp_in_F)
					{	vf[1] = true; if(debug) cout<<"16b ";}
				}

			}
			else
			{
				if(db) cout<<"Both: {"<<es.i2->getDominating()<<", "<<es.i2->getSubmissive()<<") , "<<es.i2->isLeft()<<"}"<<endl;
				sh = statusHseg2D(*(es.i1), 'F');
				vf[0] = true; if(debug) cout<<"17 ";
				if(sh.hseg->isLeft())
					S.add_left(sh, es);
				else
					S.del_right(sh, es);
				if(last_dp_in_F.isUndefined()||(!last_dp_in_F.isUndefined() && sh.hseg->getDominating() != last_dp_in_F))
				{
					last_dp_in_F = sh.hseg->getDominating();
					if(db) cout<<"look_aheadF(es.i1): "<<es.look_aheadF(es.i1)<<endl;
					if(!es.look_aheadF(es.i1))
						last_bound_in_F = sh.hseg->getDominating();
				}
				sh = statusHseg2D(*(es.i2), 'G');
				if(sh.hseg->isLeft())
					S.add_left(sh, es);
				else
					S.del_right(sh, es);
				if(last_dp_in_G.isUndefined()||(!last_dp_in_G.isUndefined() && sh.hseg->getDominating() != last_dp_in_G))
				{
					last_dp_in_G = sh.hseg->getDominating();
					if(!es.look_aheadG(es.i2))
						last_bound_in_G = sh.hseg->getDominating();
				}
				if(!last_bound_in_G.isUndefined() && !last_bound_in_F.isUndefined() && last_bound_in_F == last_bound_in_G)
				{	vf[4] = true; if(debug) cout<<"18 ";}
				else
				{
//					cout<<"vf3g1\n";
					if(!last_dp_in_G.isUndefined() && !last_bound_in_F.isUndefined() && last_bound_in_F == last_dp_in_G)
						vf[3] = true; if(debug) cout<<"19 ";
					if(!last_dp_in_F.isUndefined() && !last_bound_in_G.isUndefined() && last_bound_in_G == last_dp_in_F)
						vg[1] = true; if(debug) cout<<"20 ";
				}
			}
			//Debug printing
/*			if(!last_dp_in_F.isUndefined())
				cout<<"last_dp_in_F: "<<last_dp_in_F<<endl;
			if(!last_bound_in_F.isUndefined())
				cout<<"last_bound_in_F: "<<last_bound_in_F<<endl;
			if(!last_dp_in_G.isUndefined())
				cout<<"last_dp_in_G: "<<last_dp_in_G<<endl;
			if(!last_bound_in_G.isUndefined())
				cout<<"last_bound_in_G: "<<last_bound_in_G<<endl;
			printFlags();
*/
			es.select_next(object, status);
			if(status == end_of_first)
			{
				if(db) cout<<"end_of_first: vg02\n";
				vg[0] = true; if(debug) cout<<"21 ";
				//vg[2] = true;          //>>>>>>>>>>>>>modded
			}
			else if(status == end_of_second)
			{
				if(db) cout<<"end_of_second: vf25\n";
				vf[2] = true; if(debug) cout<<"22 ";
				//vf[5] = true;          //>>>>>>>>>>>>>modded
			}
		}


		//***********End Algorithm************
		//Test
//		vf[0] = true; vf[3] = true; vf[4] = true;
		//Debug info
		if(debug) cout<<endl;
		if(debug)
		{
			printFlags();
		}

		//Match Predicate
		MatchPred mp(vf, vg, m, n, _line2D, _line2D);
		return mp.matchll(verify);
	}
	void initializeFlags()
	{
		vf = new bool[m];
		vg = new bool[n];
		for(int i = 0; i < m; i++)
			vf[i] = false;
		for(int i = 0; i < n; i++)
			vg[i] = false;
	}
	void printFlags()
	{
		cout << "Flags: ";
		for(int i = 0; i < m; i++)
			cout << "vf[" << i << "] = " << vf[i] << ",   ";
		for(int i = 0; i < n; i++)
			cout << "vg[" << i << "] = " << vg[i] << ",   ";
		cout << endl;
	}
	bool allTrue()
	{
		bool res = true;
		for(int i = 0; i < m; i++)
			res = res && vf[i];
		for(int i = 0; i < n; i++)
			res = res && vg[i];
		return res;
	}
};
}
#endif
