/**
 * This class contain the algorithm implementation for line/region topological predicates
 * \author Reasey Praing
 * \version 0.1
 * \version 0.2
 * \date	2006-11-09
 * \note for mslob
 */
 
#ifndef ALGORITHM_LR_H
#define ALGORITHM_LR_H

#include <iostream>
#include "line2D.h"
#include "region2D.h"
#include "poi2D.h"
#include "hseg2D.h"
#include "statusHseg2D.h"
#include "EventSchedule.h"
#include "SweepLine.h"
#include "MatchPred.h"
#include "dvector.h"

namespace stu
{
using namespace stu;

class Algorithm_lr
{
private:
	bool *vf, *vg;
	int m, n;
public:
	bool debug;
	Algorithm_lr() : m(7), n(1)
	{
		debug = false;
	}
	Algorithm_lr(bool dg) : debug(dg)
	{
		m = 7;
		n = 1;
	}

	int topPred(line2D& l, region2D& r, int verify)  //verify = -1 for determination; >0 for verification; return id for determination and true answer; return -1 for false answer
	{
		debug = false;
		whichObj object;
		whatStatus status;
		initializeFlags();
		dvector<hseg2D> dyn1;
		dvector<hseg2D> dyn2;
		EventSchedule<line2D, region2D, hseg2D, hseg2D> es(l, r,dyn1,dyn2);

		//***********Begin Algorithm************

		//Create sweepline object
		SweepLine<line2D, region2D, hseg2D, hseg2D> S;
		poi2D last_dp_in_F, last_dp_in_G, last_bound_in_F;
		es.select_first(object, status);
		statusHseg2D sh, sh1;
		bool db = false;
		while(status != end_of_first && status != end_of_both && !allTrue())
		{
			if(object == first)
			{
				if(db) cout<<"First: {"<<es.i1->getDominating()<<", "<<es.i1->getSubmissive()<<") , "<<es.i1->isLeft()<<"}"<<endl;
				sh = statusHseg2D(*(es.i1), 'F');
				if(sh.hseg->isLeft())
					S.add_left(sh, es);
				else
				{
					if(!S.seg_in_region(sh))
					{
						if(db)cout<<"***SET vf[2] l68 ***\n";
						vf[2] = true; if(debug) cout<<" 1";
					}
					else
					{	vf[0] = true; if(debug) cout<<" 2";}
					S.del_right(sh, es);
				}
				if(last_dp_in_F.isUndefined()||(!last_dp_in_F.isUndefined() && sh.hseg->getDominating() != last_dp_in_F)) //>>>>>>Modded 6/20/06 <<<<<<<<<<<
				{
					last_dp_in_F = sh.hseg->getDominating();
					if(!es.look_aheadF(es.i1))
					{
						last_bound_in_F = sh.hseg->getDominating();
						if((!last_dp_in_G.isUndefined() && last_bound_in_F == last_dp_in_G) || es.look_aheadG(es.i1) || S.poi_on_seg(sh.hseg->getDominating(), 'F'))
						{	vf[5] = true; if(debug) cout<<" 3";}
						else if(S.poi_in_region(sh.hseg->getDominating(), 'F'))  //MODIFIED
						{
							if(db) cout<<"SET vf[0] vf[4] "<< S.poi_in_region(sh.hseg->getDominating(), 'F') << endl;
							vf[4]= true; if(debug) cout<<" 4";
							vf[0] = true; if(debug) cout<<" 5";
						}
						else
						{
							if(db) cout<<"SET vf[6] vf[2] l89"<<endl;
							vf[6] = true; if(debug) cout<<" 6";
							vf[2] = true; if(debug) cout<<" 7";
						}
					}
					else
					{
						if((!last_dp_in_G.isUndefined() && last_dp_in_F == last_dp_in_G) || es.look_aheadG(es.i1) || S.poi_on_seg(sh.hseg->getDominating(), 'F'))
						{	vf[3] = true; if(debug) cout<<" 8";}
					/*	else	if(S.poi_in_region(sh.hseg.getDominating(), 'F'))  //MODIFIED
						{
							//if(db) cout<<"SET vf[0] "<< S.poi_in_region(sh.hseg.getDominating(), 'F') << endl;
							vf[0]= true;
						}
						else
						{
							if(db)cout<<"***SET vf[2] l106 ***\n";
							vf[2]=true;

						}
					*/
					}
				}
				//if((!last_bound_in_F.isUndefined() && sh.hseg.getDominating() != last_bound_in_F) &&
				//				 ((!last_dp_in_G.isUndefined() && sh.hseg.getDominating() == last_dp_in_G) || es.look_aheadG(es.i1)))
				//	vf[3] = true;
				//if(S.seg_in_region(sh))
				//	vf[0] = true;

			}
			else if(object == second)
			{
				if(db) cout<<"Second: {"<<es.i2->getDominating()<<", "<<es.i2->getSubmissive()<<") , "<<es.i2->isLeft()<<", "<<es.i2->isInsideAbove()<<"}"<<endl;
				sh = statusHseg2D(*(es.i2), 'G');
				if(sh.hseg->isLeft())
					S.add_left(sh, es);
				else
				{
					S.del_right(sh, es);
					vg[0] = true; if(debug) cout<<" 9";
				}
				if(last_dp_in_G.isUndefined()||(!last_dp_in_G.isUndefined() && sh.hseg->getDominating() != last_dp_in_G))
				{
					last_dp_in_G = sh.hseg->getDominating();
					if((!last_bound_in_F.isUndefined() && last_dp_in_G == last_bound_in_F))
					{	vf[5] = true; if(debug) cout<<" 10";}
				}
			}
			else
			{
				if(db) cout<<"Both: {"<<es.i2->getDominating()<<", "<<es.i2->getSubmissive()<<") , "<<es.i2->isLeft()<<"}"<<endl;
				sh = statusHseg2D(*(es.i1), 'F');
				vf[1] = true; if(debug) cout<<" 11";
				if(sh.hseg->isLeft())
					S.add_left(sh, es);
				else
					S.del_right(sh, es);
				if(last_dp_in_F.isUndefined()||(!last_dp_in_F.isUndefined() && sh.hseg->getDominating() != last_dp_in_F))
				{
					last_dp_in_F = sh.hseg->getDominating();
					if(!es.look_aheadF(es.i1))
					{
						last_bound_in_F = sh.hseg->getDominating();
						vf[5] = true;  if(debug) cout<<" 12";                             //>>>>>>>>>>>>>>>>>>>>>>>>>ADDED 6/20/06 <<<<<<<<<<<<<<<<<<<<<<<<
					}
					else
					{	vf[3] = true; if(debug) cout<<" 13";}                             //>>>>>>>>>>>>>>>>>>>>>>>>>ADDED 6/20/06 <<<<<<<<<<<<<<<<<<<<<<<<
				}

				sh1 = statusHseg2D(*(es.i2), 'G');
				if(sh1.hseg->isLeft())
				{
					//cout<<"ADD G\n";
					S.add_left(sh1, es);
				}
				else
					S.del_right(sh1, es);

				if(last_dp_in_G.isUndefined()||(!last_dp_in_G.isUndefined() && sh1.hseg->getDominating() != last_dp_in_G))
				{
					last_dp_in_G = sh1.hseg->getDominating();
				}

				/*std::vector<statusHseg2D>::iterator i;
				for(i = S.status.begin(); i != S.status.end(); i++)
				{
					cout<<i->owner<<": {"<<i->hseg.getDominating()<<", "<<i->hseg.getSubmissive()<<") , "<<i->hseg.isLeft()<<", "<<i->hseg.isInsideAbove()<<"}"<<endl;
				}
				*/
			}
			es.select_next(object, status);

			if(status == end_of_second)
			{
				if(db)cout<<"***SET vf[2] l178 ***\n";
				vf[2] = true; if(debug) cout<<" 14";
				//vf[6] = true;                           >>>>>>>>>>>>>>>>>>>>>>>>>>>>>Taken out 6/20/06 <<<<<<<<<<<<<<<<<<<<<<<<<
			}
			//debug
			//printFlags();
		}
		if(status == end_of_first)
		{
			vg[0] = true; if(debug) cout<<" 15";
		}


		//***********End Algorithm************
		//Test
//		vf[0] = true; vf[1] = true; vf[3] = true; vf[4] = true; vf[5] = true;
		//Debug info
		if(debug) cout<<endl;
		if(debug || db)
		{
			printFlags();
		}

		//Match Predicate
		MatchPred mp(vf, vg, m, n, _line2D, _region2D);
		return mp.matchlr(verify);
	}
	void initializeFlags()
	{
		vf = new bool[m];
		vg = new bool[n];
		for(int i = 0; i < m; i++)
			vf[i] = false;
		for(int i = 0; i < n; i++)
			vg[i] = false;
	}
	void printFlags()
	{
		cout << "Flags: ";
		for(int i = 0; i < m; i++)
			cout << "vf[" << i << "] = " << vf[i] << ",   ";
		for(int i = 0; i < n; i++)
			cout << "vg[" << i << "] = " << vg[i] << ",   ";
		cout << endl;
	}
	bool allTrue()
	{
		bool res = true;
		for(int i = 0; i < m; i++)
			res = res && vf[i];
		for(int i = 0; i < n; i++)
			res = res && vg[i];
		return res;
	}
};
}
#endif
