/**
 * This class contain the algorithm implementation for point/point topological predicates
 * \author Reasey Praing
 * \version 0.1
 * \version 0.2
 * \date	2006-11-06 
 * \note for mslob
 */
#ifndef ALGORITHM_PP_H
#define ALGORITHM_PP_H

#include <iostream>
#include "point2D.h"
#include "poi2D.h"
#include "EventSchedule.h"
#include "MatchPred.h"
#include "dvector.h"


namespace stu
{
using namespace stu;

class Algorithm_pp
{
private:
	bool *vf, *vg;
	int m, n;
public:
	bool debug;
	Algorithm_pp() : m(2), n(2) 
	{
		debug = false;
	}
	Algorithm_pp(bool dg) : debug(dg)
	{
		m = 2;
		n = 2;
	}
	int topPred(point2D& p1, point2D& p2, int verify) //verify = -1 for determination; >0 for verification; return id for determination and true answer; return -1 for false answer
	{
		debug = false;
		whichObj object;
		whatStatus status;
		initializeFlags();
		dvector<poi2D> dyn1, dyn2;
		EventSchedule<point2D, point2D, poi2D, poi2D> es(p1, p2,dyn1,dyn2);
		
		//***********Begin Algorithm************
		es.select_first(object, status);
		while(status == end_of_none && !allTrue())
		{
			if(object == first)
			{	vf[0] = true; if(debug) cout<<"1 ";}
			else if(object == second)
			{	vg[0] = true; if(debug) cout<<"2 ";}
			else
			{
				vf[1] = true;  if(debug) cout<<"3 ";
				vg[1] = true;
			}	
			es.select_next(object, status);
		}
		if(status == end_of_first)
		{	vg[0] = true; if(debug) cout<<"4 ";}
		else if(status == end_of_second)
		{	vf[0] = true;  if(debug) cout<<"5 ";}
		//***********End Algorithm************
		if(debug) cout<<endl;
		//Debug info
		if(debug)
		{
			printFlags();
		}

		//Match Predicate
		MatchPred mp(vf, vg, m, n, _point2D, _point2D);
		//cout<<endl<<verify<<endl;
		return mp.matchpp(verify);
	}
	void initializeFlags()
	{
		vf = new bool[m];
		vg = new bool[n];
		for(int i = 0; i < m; i++)
			vf[i] = false;
		for(int i = 0; i < n; i++)
			vg[i] = false;
	}
	void printFlags()
	{
		cout << "Flags: ";
		for(int i = 0; i < m; i++)
			cout << "vf[" << i << "] = " << vf[i] << ",   ";
		for(int i = 0; i < n; i++)
			cout << "vg[" << i << "] = " << vg[i] << ",   ";
		cout << endl;
	}
	bool allTrue()
	{
		bool res = true;
		for(int i = 0; i < m; i++)
			res = res && vf[i];
		for(int i = 0; i < n; i++)
			res = res && vg[i];
		return res;
	}
};
}
#endif
