#include "block2D.h"

namespace stu{
	
		using namespace stu;

		short int block2D::FLAGS=1;
		
		/////////////block iterator methods

		block2D::Iterator::Iterator(block2D* par):current(-1), parent(par) {}
		block2D::Iterator::Iterator():current(-1), parent(NULL) {}
	
		bool block2D::Iterator::next(){ 
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			else current++;			
			return (!end());
		}
	
		hseg2D* block2D::Iterator::get(){
		
		
			if (current<FLAGS) cerr << "Need to move to next element to retrieve from iterator. " << endl;
		
			Locator hseg(parent->elements.locate(current));
/*			cout << "Parent has " << parent->elements.getElements() << " elements. Retrieving number: " << current << endl;*/
// 			cout << "The hseg to retrieve: "; hseg.debug(); 
			uint len=hseg.length(); //note that length only "really" works if hseg is base object...
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=hseg.getStream();
			reader.read(buffer,len,nread);
			hseg2D *temp = new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer	
			return temp;
		}
	
		bool block2D::Iterator::end(){
			//take into account that first element should always be valid flag
			return (current > static_cast<long long int>(parent->elements.count()-1) || static_cast<long long int>(parent->elements.count())<=FLAGS);
		}
		
		block2D::Iterator block2D::Iterator::operator+( int num )
		{
			Iterator temp = *this;
			if (temp.current<FLAGS) temp.current=FLAGS+num; //skip valid flag!
			else temp.current = temp.current+num;
			return temp;
		}
		block2D::Iterator block2D::Iterator::operator-( int num )
		{
			Iterator temp = *this;
			if (temp.current<=FLAGS) 
				temp.current=-1;
			else
				temp.current = temp.current-num;
			return temp;	
		}
		block2D::Iterator block2D::Iterator::operator++( int dummy )
		{
			Iterator temp = *this;
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			else current++;
			return temp;
		}
		block2D::Iterator block2D::Iterator::operator--( int dummy )
		{
			Iterator temp = *this;
			if (current<=FLAGS) 
				current=-1;
			else
				current--;
			return temp;	
		}
		block2D::Iterator& block2D::Iterator::operator+=( int num )
		{
			if (current<FLAGS) current=FLAGS+num; //skip valid flag!
			else current = current+num;
			return *this;
		}
		block2D::Iterator& block2D::Iterator::operator-=( int num )
		{
			current = current - num;
			if( current < FLAGS ) current = FLAGS;
			return *this;
		}
	
		///////////////////////////////////
		
		hseg2D block2D::operator[]( uint index )
		{
			block2D::Iterator bIter( this );
			bIter.next( );
			bIter = bIter+index;
			return *bIter.get();
		}
		
		void block2D::loadValid(){
			changed=false;
			Locator flg(elements.locate(0));
			uint len=flg.length(); //the flag length should be 1!
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=flg.getStream();
			reader.read(buffer,len,nread);
			valid=(*buffer=='V');
/*			cout << "Bufvalid: " << buffer[0] << endl;
			cout << "Current block: "; elements.debug();*/
		}

		void block2D::saveValid(){
			if (changed){
/*				cout << "Will remove/save Valid for block: "; elements.debug();*/
				if (elements.count()>0) {elements.remove(0);
/*					cout << "REMOVED valid: "; elements.debug();*/
				}
				unsigned char *buffer=new unsigned char;
				if (valid) *buffer='V';  //valid
				else *buffer='I'; //invalid
				elements.insert(buffer,1,0);
/*				cout << "ADDED valid: "; elements.debug();*/
			}
			changed=false;
		}
		
		block2D::block2D():global(false), elements(false), valid(false), changed(true), inBatch(false), parent(NULL){
			parent=new line2D();
			global=parent->global;
			elements=parent->addBlock().elements;
		}

		//from the given locator
		block2D::block2D(const line2D& l, const Locator& b):global(l.global), elements(b), valid(false), changed(true), inBatch(false), parent(const_cast<line2D*>(&l)) {
			if (elements.count()>0)
				loadValid();
			else
				saveValid(); //first save

// 			cout << "New loaded blk: "; elements.debug();
		}

		block2D::block2D(line2D& l):global(l.global), elements(l.blks.insert(l.blks.count(),NONE_LEVEL)), valid(false), changed(true), inBatch (false),  parent(&l){
			
			saveValid(); //first save
		}
		
		block2D::block2D(line2D& l, const block2D& b):global(l.global), elements(l.blks.insert(l.blks.count(),NONE_LEVEL)), valid(b.valid), changed(true), inBatch (false),  parent(&l){
			
			saveValid(); //first save
			elements.beginBatch();
		
			block2D::Iterator bi=b.getIterator();
			hseg2D *t;

			while (bi.next()){
				t=bi.get();
				addhseg(*t);
			}

			elements.commitBatch();
		}
		
		//retrieve block at idx of line2D p
/*		block2D::block2D(const line2D& p, uint idx):parent(const_cast<line2D*>(&p)),elements(parent->blks.locate(idx)),valid(true) {*/
			//read first base element containing a character specifying whether this block is stored "valid"
// 			Locator fin=elements.locate(0);
// 			unsigned char* d=new unsigned char;
// 			iSlobstream r=fin.getStream();
// 			uint nread=0;
// 			r.read(d,1,nread);
// 			valid=(*d=='F');
// 			delete d;
// 		} 
		
	
/*		//build a new block for p and add ss
		block2D::block2D(const line2D& p, const seg2D ss[], uint length):p(&p), elements(parent->blks.insert(parent->blks.count())), valid(false) {
// 			saveValid(); //set first subobject to invalid. for consistency
			for (uint i=0; i<length; i++) addSegment(ss[i]);
		}*/
		
		//copy bs as a new block of p
/*		block2D::block2D(const line2D& p, const block2D& bs):parent(const_cast<line2D*>(&p)), elements(parent->blks.insert(parent->blks.count())), valid(bs.valid){
			
			if (!bs.isValid())
				throw invalidObjectException(); //object bs must be valid before copy can be made part of p
			
			block2D::Iterator bi=bs.getIterator();
			hseg2D* t;
			
			if (bi.next()) t=&(bi.get());
			while (!bi.end()){
				addhseg(*t);
				if (bi.next()) t=&(bi.get());
			}
		}*/
		
		block2D::~block2D(){}
		
		//constructor ops
		void block2D::addSegment(const seg2D &s)
		{
			hseg2D p(s.getP(),s.getQ(),true);
			p.validate();
			if (addhseg(p)) valid=false;

			
			hseg2D q(s.getQ(),s.getP(),false);
			q.validate();
			if (addhseg(q)) valid=false;
			
		}
		
		//adds all segs, leaves checking to validate
		void block2D::addSegments(const seg2D ss[], uint length) // throw (validObjectException);
		{
			for (uint i=0; i<length; i++)
				addSegment(ss[i]);	
		}
		
		void block2D::removeSegment(const seg2D &s)  throw (undefinedSpatialObjectException)
		{			
			if (s.isUndefined())
				throw undefinedSpatialObjectException();

// 			hseg2D p(s.getP(),s.getQ(),true);
// 			hseg2D q(s.getQ(),s.getP(),false);

// 			block2D::Iterator bi=getIterator();
// 			
// 			hseg2D *t;
// 			
// 			if (bi.next()) t=bi.get();
// 			uint loc=FLAGS; //first element is valid flag, so skip
// 			
// 			while (!bi.end() && *t!=p) 
// 				if (bi.next()) {
// 					t=bi.get();
// 					loc++;
// 				}
// 			
// 			if (!bi.end())
// 			{
// 				elements.remove(loc); //erase p
// 				t=bi.get();//once erase, re-get new element at current
// 				while (!bi.end() && *t!=q) 
// 					if (bi.next()) {
// 						t=bi.get();
// 						loc++;
// 					}
// 				if (!bi.end())
// 					elements.remove(loc); //erased p, now erase q
// 				else
// 					throw undefinedSpatialObjectException();
// 			}
// 			else
// 				throw undefinedSpatialObjectException();
			
			parent->removeSegment(s); //done after to allow block locator to update self, although not as good for performance
		}
		
		void block2D::removeMe() { //removes all of this block's hsegs from the primary structure...
			unsigned char *buffer=NULL;
			while (static_cast<long long int>(elements.count())>FLAGS){
				Locator hseg(elements.locate(FLAGS));
				Locator hsegref(elements.locateRef(FLAGS));
				//cout << "Will remove hseg: "; hseg.debug();
				//cout << "Referenced through: "; hsegref.debug();
				uint len=hseg.length(); //note that length only "really" works if hseg is base object...
				if (buffer!=NULL) delete buffer;
				buffer=new unsigned char[len];
				uint nread=0; //number of bytes read
				imSlobstream reader=hseg.getStream();
				reader.read(buffer,len,nread);
				hseg2D *temp=new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer	
			
				parent->removeHalfSegment(*temp);
				//cout << "removed hseg!" << endl;
				global.getMySlob()->sinx->debug();
			}
			
			//then its just the flags...remove...
			while (elements.count()>0){
				//cout << "will remove flag: "; elements.locate(0).debug();
				elements.remove(0);
				//cout << "Removed flag!" << endl;
				global.getMySlob()->sinx->debug();
			}
			
			//cout << "Emptied Myself: "; elements.debug();
		}
		
		
		
// 		std::vector<hseg2D>& block2D::getElements()
// 		{
// 			return elements;
// 		}


		bool block2D::validate()
		{
			//assume its finalizable...if violation, set otherwise.
// 			if (!valid){
// 				valid=true;
// 				changed=true;
// 			}
// 			saveValid();
			
			// actually validate it.
			// make sure all segments are connected and no self intersections occur (no loops either)
			
			// first use the sweep line to check if any segments intersect
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			block2D tempBl;
			EventSchedule<block2D, block2D, hseg2D, hseg2D> eventSched( *this, tempBl, dyn1, dyn2 );
			SweepLine<block2D, block2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
			while(status != end_of_both )
			{
				if(object == first || object == both )
				{
					sh = statusHseg2D(*(eventSched.i1), 'F');
					if(eventSched.i1->isLeft())
					{
						if( S.add_left(sh, eventSched) )
						{
							valid = false;
							changed = true;
							saveValid( );
							cerr<<"Not a valid block: intersecting segments"<<endl;
							return false;
						}
					}
					else
					{
						S.del_right(sh, eventSched);
					}
				}
				eventSched.select_next(object, status);
			}
			
			// now check that the block is connected.
			// recursively step through the block until you can go no more.
			
			
			if( size() > 0 )
			{
				uint numVisited = 0;
				vector<hseg2D> alreadyVisitedVector;
				vectorBinarySearchWrapper< vector<hseg2D>, hseg2D > alreadyVisitedWrapper( &alreadyVisitedVector );
				vectorBinarySearchWrapper< block2D, hseg2D > blockSearchWrapper( this ); 
				hseg2D startRight = (*this)[0];
				hseg2D startLeft;
				startLeft.addPoints( startRight.getSubmissive(), startRight.getDominating(), !startRight.isInsideAbove() ); 
				// walk the hseg going right from the current hseg
				walkBlock( startRight, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );

				// now walk going left from the starting hseg
				// don't count the start hseg twice:
				numVisited-=2;
				// remove the startRight and startLeft fromt he already visited vector
				vector<hseg2D>::iterator itemHseg;
				uint index = 0;
				if( alreadyVisitedWrapper.find( startRight, index) )
				{
					itemHseg = alreadyVisitedVector.begin();
					itemHseg += index;
					alreadyVisitedVector.erase( itemHseg );
				}
				else
				{
					//error, it should be there
					throw runtime_error( " could not find startRight in already visited list ");
				}
				if( alreadyVisitedWrapper.find( startLeft, index) )
				{
					itemHseg = alreadyVisitedVector.begin();
					itemHseg += index;
					alreadyVisitedVector.erase( itemHseg );
				}
				else
				{
					//error, it should be there
					throw runtime_error( " could not find startLeft in already visited list ");
				}
				
				// now walk the opposite direction
				walkBlock( startLeft, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );

				// finally, check if it is, in fact, connected
				//cerr<<"numvisit, size: "<<numVisited<<", "<<size()<<endl;
				if( numVisited != size() )
				{
					valid = false;
					changed = true;
					saveValid( );
					cerr<<"Not a valid block: not connected"<<endl;
					return false;
				}
			}
			
// 			vector<poi2D> endPoints;
// 			vector<poi2D>::iterator currentPoiPosition;
// 			vector<uint> endPointFrequency;
// 			vector<uint>::iterator currentFreqPosition;
// 			vectorBinarySearchWrapper< vector<poi2D>, poi2D > binSearcher( &endPoints );
// 			hseg2D currHseg;
// 			poi2D currPoi;
// 			block2D::Iterator bIter( this );
// 			uint index;
// 			while( bIter.next( ) )
// 			{
// 				currHseg = *bIter.get( );
// 				currPoi = currHseg.getDominating( );
// 				if( binSearcher.find( currPoi, index ) )
// 				{
// 					// if the point is found, update the frequencey
// 					endPointFrequency[index]++;
// 				} else
// 				{
// 					// if the endpoint is not found, insert it and make room 
// 					// in the frequencey vector, setting the frequency to 1
// 					currentPoiPosition = endPoints.begin();
// 					currentPoiPosition += index;
// 					endPoints.insert( currentPoiPosition, currPoi );
// 					currentFreqPosition = endPointFrequency.begin();
// 					currentFreqPosition += index;
// 					endPointFrequency.insert( currentFreqPosition, 1 );
// 				}
// 			}
// 			
// 			// now we have constructed the frequency vector
// 			// so now we must traveser it and find EXACTLY 2 points
// 			// with frequency 1, and the rest with frequency 2
// 			uint endPointCount = 0;
// 			for( uint i = 0; i < endPointFrequency.size(); i++ )
// 			{
// 				if( endPointFrequency[i] == 1 )
// 				{
// 					endPointCount++;
// 					if( endPointCount > 2 )
// 					{
// 						valid = false;
// 						changed = true;
// 						saveValid( );
// 						cerr<<"Not a valid block: wrong number of endpoints"<<endl;
// 						return;
// 					}
// 				}
// 				else if( endPointFrequency[i] > 2 || endPointFrequency[i] < 1 )
// 				{
// 					valid = false;
// 					changed = true;
// 					saveValid( );
// 					cerr<<"Not a valid block: self intersecting. "<<endPointFrequency[i]<<" intersecting endpoints"<<endl;
// 					return;
// 				}
// 			}
// 			if( endPointCount != 2 )
// 			{
// 				valid = false;
// 				changed = true;
// 				saveValid( );
// 				cerr<<"Not a valid block: not enough endpoints: "<<endPointCount<<endl;
// 				return;
// 			}
			
			valid=true;
			changed=true;
			saveValid( );
			cout << "Valid Block: " << *this << endl;
			return true;
		}
		
		void block2D::walkBlock( hseg2D currHseg, uint &numVisited, vectorBinarySearchWrapper< vector<hseg2D>, hseg2D > &alreadyVisitedWrapper, vector<hseg2D> &alreadyVisitedVector, vectorBinarySearchWrapper< block2D, hseg2D > &blockSearchWrapper )
		{
			// make sure we have not been here already
			uint index;
			if( alreadyVisitedWrapper.find( currHseg, index ) )
				return;
			
			// visit this hseg
			vector<hseg2D>::iterator visitedIter = alreadyVisitedVector.begin();
			visitedIter += index;
			alreadyVisitedVector.insert( visitedIter, currHseg );
			numVisited++;
			
			//now visit any hsegs that emit from this one.
			// construct this one's brother
			hseg2D brother;
			brother.addPoints( currHseg.getSubmissive( ), currHseg.getDominating(), !currHseg.isInsideAbove( ) );
			
			// make sure we have not already visited the brother
			// add it to the visited list if we have not been there yet
			if( alreadyVisitedWrapper.find( brother, index ) )
			{
				return;
			} else
			{
				numVisited++;
				visitedIter = alreadyVisitedVector.begin();
				visitedIter += index;
				alreadyVisitedVector.insert( visitedIter, brother );
			}
			
			// find the brother
			if( !blockSearchWrapper.find( brother, index) )
			{
				// we didnt find the brother in the block;
				throw runtime_error( "brother not found in validation" );
				return;
			}
			
			// now look left in the list from the brother for the next connecting hseg
			uint brotherIndex = index;
			if( index > 0 )
			{
				hseg2D nextHseg;
				// quit when the x coord of the dominaitng endpoints differs.  if this ..
				// happens, the segments can't connect
				do {
					nextHseg = (*this)[index-1];
					index--;
					// if the dominaitng endpoints are the same, visit the hseg
					if( nextHseg.getDominating() == brother.getDominating() )
					{
						walkBlock( nextHseg, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );
					}
				} while( nextHseg.getDominating().getX( ) == brother.getDominating().getX() && index > 0);
			}
			// now look right in the list from the brother for the next connecting hseg;
			index = brotherIndex;
			if( index < size()-1 )
			{
				hseg2D nextHseg;
				// quit when the x coord of the dominaitng endpoints differs.  if this ..
				// happens, the segments can't connect
				do {
					nextHseg = (*this)[index+1];
					index++;
					// if the dominating endpoints are the same, visit the hseg
					if( nextHseg.getDominating() == brother.getDominating() )
					{
						walkBlock( nextHseg, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );
					}
					
				} while( nextHseg.getDominating().getX( ) == brother.getDominating().getX() && index < size( )-1);
				
			}
			
			// now we have visited all hsegs connecting to this one, return
		}
		
		uint block2D::size() const
		{
			return (elements.count()-FLAGS);
		}
		
		bool block2D::isValid() const
		{
			return valid;
		}

		uint block2D::getSegmentCount() const //returns the number of segments for the whole block
		{
			if (valid)
				return ((elements.count()-FLAGS)/2); //subtract 1 for valid flag
			else
				throw runtime_error("Cannot retrieve segment count of invalid block.");
		}
						
		rat block2D::getLength() const //returns the perimeter. sum of lenghts of segments
		{
			rat result(0);
			
			block2D::Iterator bi=getIterator();
			hseg2D * t;
			
			
			while (bi.next())
			{
				t=bi.get();
				if (t->isLeft()) result+=t->getLength();
			}

			return result;
		}
		
		bool block2D::isEmpty() const //returns getSize()==0
		{
			return (elements.count()<2); //first element could be valid flag
		}

		block2D::Iterator block2D::getIterator() const //sorted in half-segment order.		
		{
			block2D::Iterator p(const_cast<block2D*>(this));
			return p;
		}
		
		bool block2D::addhseg(const hseg2D &h) throw (invalidObjectException)
		{
			if (!h.isValid())
				throw invalidObjectException("Invalid HalfSegment: Cannot be added to block.");
		
			Locator added(false);
			uint loc=FLAGS; //loc starts here cause 0 is valid flag
			hseg2D *t;

			if (parent!=NULL){
				added=parent->addhseg(h);
				
			}else{ //odd case when block is on its own...
// 				uint sp=h.serialSize();
// 				unsigned char *data=new unsigned char[sp];
// 				uint len=h.serialize(data);
// 				added=elements.append(data,len);
// 				return true;
				throw runtime_error("No self blocks daddy!");
			}
			//now add reference to secondary structure of line (this block)
/*			cout << "Will add reference to "; added.debug();
			cout << "to this block: "; elements.debug();*/
// 			block2D::Iterator bi=getIterator();
// 			loc=FLAGS;
// 			
// 			while (bi.next()){
// 				t=bi.get();
// /*				cout << "Current t: " << *t << endl;;*/
// 				if (*t==h)
// 					return false; //do not add, duplicate
// 				if (*t>h)
// 					break; //then add here		
// 				loc++;
// 			}
// 		
// 			if (bi.end()) //reached end so insert last
// 				elements.insert(added,elements.count());
// 			else
// 				elements.insert(added,loc);//add p to the end.
			
			vectorBinarySearchWrapper< block2D, hseg2D > finder ( this ); 
			
			uint found=0;
			
			if (finder.find(h,found)){
				return false; //do not add, duplicate
			}else
			{
				long loc=static_cast<long>(found)+FLAGS;
				//cout << "Will insert hseg in block in position: " << loc << endl;
				elements.insert(added,loc);//add to block
			}	
/*			cout << "Added hseg to block, elements: "; elements.debug();
			cout << "The block so far: " << *this << endl;*/
			return true;

		}

		std::ostream& operator << (std::ostream &ostr, const block2D &rhs) throw( invalidObjectException )
		{
			if( !rhs.isValid( ) ) {
				ostr<< "--(Invalid Block)--" ;
				//throw invalidObjectException( "Invalid Block: Output stream operator." );
			} 
			
			//cout << "There are " << rhs.elements.count() << " pois in this point" << endl;
/*				cout << "Elements of the block: "; rhs.elements.debug();*/
			block2D::Iterator p1=rhs.getIterator();
			hseg2D* pp1;
			if (rhs.isValid()) ostr << rhs.getSegmentCount() << " segments-> ";
			ostr << "[";
			while (p1.next()){
				pp1=p1.get();
				ostr << ", " << *pp1;
			}
			ostr << "]";
			
			return ostr;
		}
} //namespace
