#include "line2D.h"

#define min(a,b)=(a<b?a:b)
#define max(a,b)=(a>b?a:b)

namespace stu{
	
		using namespace stu;

		short int line2D::FLAGS=1;
		
		////////////line iterator methods
		line2D::Iterator::Iterator(){}
		
		line2D::Iterator::Iterator(line2D* par):current(-1), parent(par) {}
	
		bool line2D::Iterator::next(){ 
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			else current++;
			return (!end());
		}
		bool line2D::Iterator::prev(){		//added  --Reasey
			if(current>FLAGS)
			{
				current--;
				return true;
			}
			else
				return false;
		}
		hseg2D* line2D::Iterator::get(){
		
			if (current<FLAGS) cerr << "Need to move to next element to retrieve from iterator. " << endl;
			//cout << "Current: " << current << endl;
			
			Locator hseg(parent->hsegs.locate(current));
			uint len=hseg.length(); //note that length only "really" works if hseg is base object...
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=hseg.getStream();
			reader.read(buffer,len,nread);
			hseg2D* temp=new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer	
			
			return temp;
		}
	
		bool line2D::Iterator::end(){
			//take into account that first element should always be finalized flag
			return (current>static_cast<long long int>(parent->hsegs.count())-FLAGS || static_cast<long long int>(parent->hsegs.count()) <= FLAGS);
		}
		
		bool line2D::Iterator::begin(){	//added  --Reasey
			return (current==FLAGS && static_cast<long long int>(parent->hsegs.count()) > FLAGS);
		}
		
		line2D::Iterator line2D::Iterator::operator+( int num )
		{
			Iterator temp = *this;
			
			if (temp.current<FLAGS) temp.current=FLAGS+num; //skip valid flag!
			else temp.current = temp.current+num;
			
			return temp;
		}
		line2D::Iterator line2D::Iterator::operator-( int num )
		{
			Iterator temp = *this;
			if (temp.current<=FLAGS) 
				temp.current=-1;
			else
				temp.current = temp.current-num;
			return temp;	
		}
		line2D::Iterator line2D::Iterator::operator++( int dummy )
		{
			Iterator temp = *this;
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			else current++;
			cout << current << endl;
			return temp;
		}
		line2D::Iterator line2D::Iterator::operator--( int dummy )
		{
			Iterator temp = *this;
			if (current<=FLAGS) 
				current=-1;
			else
				current--;
			return temp;
		}
		line2D::Iterator& line2D::Iterator::operator+=( int num )
		{
			if (current<FLAGS) current=FLAGS+num; //skip valid flag!
			else current = current+num;
			return *this;
		}
		line2D::Iterator& line2D::Iterator::operator-=( int num )
		{
			current = current - num;
			if( current < FLAGS ) current = FLAGS;
			return *this;
		}
		
		hseg2D line2D::operator[]( uint index )
		{
			line2D::Iterator lIter( this );
			lIter.next( );
			lIter = lIter+index;
			return *lIter.get();
		}
		
		uint line2D::size() const
		{
			return (hsegs.count()-FLAGS);
		}
	
		///////////////////////////////////
		
		void line2D::loadValid(){
			changed=false;
			Locator flg(hsegs.locate(0));
			uint len=flg.length(); //the flag length should be 1!
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=flg.getStream();
			reader.read(buffer,len,nread);
			valid=(*buffer=='V');
/*			cout << "Buvalid: " << buffer[0] << endl;*/
		}

		void line2D::saveValid(){
			if (changed){
/*				cout << "Will remove/save valid for line with PS: "; hsegs.debug();*/
				if (hsegs.count()>0) {hsegs.remove(0);
/*					cout << "REMOVED valid: "; hsegs.debug();*/
				}
				unsigned char *buffer=new unsigned char;
				if (valid) *buffer='V'; 
				else *buffer='I';
				hsegs.insert(buffer,1,0);
/*				cout << "ADDED valid: "; hsegs.debug();*/
			}
			changed=false;
		}

		line2D::line2D(bool create):global(create),hsegs(false), blks(false), valid(false), changed(create), inBatch(false){
			if (create)
			{
				global=global.insert(0,OBJECT_LEVEL); //move global one level down OBJECT_LEVEL
				hsegs=global.insert(0,NONE_LEVEL); //insert primary structure
				blks=global.insert(1,NONE_LEVEL); //insert secondary structure
				saveValid();
			}
		}
		
		line2D::line2D(const Locator& m):global(m), hsegs(false), blks(false),  valid(false), changed(true), inBatch(false) {
//			cout << "Global count: " << global.count() << endl;
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				blks=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				blks=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				saveValid(); //first save
 			cout << "GLOBAL: "; global.debug();
 			cout << "HSEGS: "; hsegs.debug();
 			cout << "BLKS: "; blks.debug();
		}
		
		line2D::line2D(const Locator& m, const block2D &b):global(m), hsegs(false), blks(false), valid(false), changed(true), inBatch(false){		
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				blks=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				blks=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				saveValid(); //first save

			addBlock(b);
		}

		line2D::line2D(const Locator& m, const block2D bs[], uint length):global(m), hsegs(false), blks(false), valid(false), changed(true), inBatch(false)
		{
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				blks=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				blks=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				saveValid(); //first save

			addBlocks(bs,length);
		}
		
		line2D::line2D(const Locator& m, const line2D &ls):global(m), valid(ls.valid), changed(ls.valid), inBatch(false) {
			//copy line2D ls as a whole....no need to go element by element
		}
		
		line2D::~line2D(){}
		
		//constructor ops
		block2D line2D::addBlock(const block2D &b)
		{	//b should be from a different mSLob, so copy it
			
			if (valid) {
				valid=false; //invalidate current object until is newly validated
				changed=true;
			}
			
			uint cid=blks.count();
			
/*			cout << "GLOBAL1: "; global.debug();
			cout << "HSEGS1: "; hsegs.debug();
			cout << "BLKS1: "; blks.debug();*/
			Locator newblk(blks.insert(cid,NONE_LEVEL));
/*			cout << "NewBlock: "; newblk.debug();*/
			
			block2D::Iterator b1=b.getIterator();
			hseg2D* t;
			
			while (b1.next())
			{
				t=b1.get();
				Locator temp(addhseg(*t));
				newblk.insert(temp,newblk.count()); //always append as hsegs are being read in order anyway
			}
			
			block2D toReturn(global,newblk);
			//toReturn->parent=this;

			if (!inBatch) saveValid();

			return toReturn;
		}
		
 		block2D line2D::addBlock()
		{	//create new empty block and return it

			//no need to invalidate as new empty block does nothing wrong
			Locator newblk(blks.insert(blks.count(),NONE_LEVEL));
/*			cout << "GLOBAL2: "; global.debug();
			cout << "HSEGS2: "; hsegs.debug();
			cout << "BLKS2: "; blks.debug();
			cout << "NewBlock2: "; newblk.debug();*/
			block2D toReturn(*this, newblk);
//			toReturn->parent=this;
			return toReturn;
		}
		
		
		//adds all blocks, leaves checking to validate
		void line2D::addBlocks(const block2D bs[], uint length) throw (invalidObjectException)
		{
			inBatch=true;
			for (uint i=0; i<length; i++)
				addBlock(bs[i]);
			inBatch=false;
			saveValid();
		}
		
		block2D line2D::getBlock(uint idx){ //returns the idx block of this line
			if (idx<blks.count())
				return block2D(*this,blks.locate(idx));
			else{
				cerr << "Invalid block index!" << endl;
				exit(1);
			}
		}
		
// 		bool line2D::removeBlock(uint idx)
// 		{
// 			Locator blk(blks.locate(idx));
// 
// 			cout << "Block to remove: "; blk.debug();
// 			
// 			block2D up(*this, blks.locate(idx));
// 			
// 			//now strongRemove all segments associated to this block
// 			hseg2D* e;
// 			hseg2D* t=NULL;
// 			unsigned char *buffer=NULL;
// 			uint len, nread;
// 			uint cur=FLAGS; //skip this valid flag
// 			
// 			//elements in bi are sorted, so they can be removed from primary in that order and keep executing non-cuadratic
// 			while (up.elements.count()>up.FLAGS){ //for every element in bi
// 				//if (bi.next()) //no need for get as each deletion removes the current, thus the next one becomes the current
// 				
// 				Locator delhseg(up.elements.locate(up.FLAGS));
// 				len=delhseg.length();
// 				if (buffer!=NULL) delete buffer;
// 				buffer=new unsigned char[len];
// 				nread=0; //number of bytes read
// 				imSlobstream readerdel=delhseg.getStream();
// 				readerdel.read(buffer,len,nread);
// 				e = new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer
// 				
// 				Locator hseg(hsegs.locate(cur));
// 				uint len=hseg.length(); //note that length only "really" works if hseg is base object...
// 				if (buffer!=NULL) delete buffer;
// 				buffer=new unsigned char[len];
// 				nread=0; //number of bytes read
// 				imSlobstream reader=hseg.getStream();
// 				reader.read(buffer,len,nread);
// 				t = new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer
// 				
// 				while (cur<hsegs.count() && *e>*t){
// 					cur++;
// 					Locator hseg(hsegs.locate(cur));
// 					len=hseg.length(); //note that length only "really" works if hseg is base object...
// 					if (buffer!=NULL) delete buffer;
// 					buffer=new unsigned char[len];
// 					nread=0; //number of bytes read
// 					imSlobstream reader=hseg.getStream();
// 					reader.read(buffer,len,nread);
// 					t = new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer
// 				}
// 				if (cur>=hsegs.count()) //then didnt find it...error
// 					throw runtime_error("Couldn't remove object referenced...something is funny here!");
// 				else{
// 					hsegs.remove(cur);
// 					cout << "Removed Hseg, Blk: "; blk.debug();
// 				}
// 			}
// 			if (buffer!=NULL) delete buffer;
// 
// 			cout << "Empty flagged blk: "; blk.debug();
// 			while (blk.count()>0)
// 				blk.remove(0); //remove flgs
// 			cout << "Empty blk: "; blk.debug();
// 			blks.remove(idx); //should be empty by now
// 			return true;
// 		}

		bool line2D::removeBlock(uint idx)
		{
			Locator blk(blks.locate(idx));

			cout << "will remove block: "; blk.debug();
			cout << "from: "; blks.debug();
			
			block2D up(*this, blks.locate(idx));
			
			global.getMySlob()->sinx->debug();
			up.removeMe();
			cout << "removed" << endl;
			if (!blks.remove(idx))
				return false;
 			global.getMySlob()->sinx->debug();
			cout << "blks NOW: "; blks.debug();

			return true;//should be empty by now
		}
		
		bool line2D::validate()
		{ 
			
			//cout << "Validating Line" << endl;
			//assume its valid at first. if something violates, then set to false
			
			// first make sure there are no self intersections
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			line2D tempL;
			EventSchedule<line2D, line2D, hseg2D, hseg2D> eventSched( *this, tempL, dyn1, dyn2 );
			SweepLine<line2D, line2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
			while(status != end_of_both )
			{
				if(object == first || object == both )
				{
					sh = statusHseg2D(*(eventSched.i1), 'F');
					if(eventSched.i1->isLeft())
					{
						if( S.add_left(sh, eventSched) )
						{
							valid = false;
							changed = true;
							if (!inBatch) saveValid();
							cerr<<"Not a valid line: intersecting segments"<<endl;
							return valid;
						}
					}
					else
					{
						S.del_right(sh, eventSched);
					}
				}
				eventSched.select_next(object, status);
			}
			
			
			if (!valid) {
				valid=true;
				changed=true;
			}
			if (!inBatch) saveValid();
			return valid;
 		}
		
		uint line2D::getSegmentCount() const //returns the number of segments for the whole line
		{ 
			return ((hsegs.count()-FLAGS)/2); //subtract valid flag
		}

		uint line2D::getBlockCount() const//number of blocks
		{
			return blks.count();
		}

		rat& line2D::getLength() const //returns the perimeter. sum of lenghts of segments
		{ 
			//because every segment is stored twice, then sum all hseg lengths and divide by 2.
			rat tlength(0);

			if (!valid) return *(new rat(tlength));; //invalid line has length of 0

			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D *t=li.get();
				if (t->isLeft()) tlength+=t->getLength();
			}

			return *(new rat(tlength));
		}
		 
		
						//returns the minimum distance between this and other
		rat line2D::distance(const point2D &other) const 
		{
			//for now implemented as cuadratic
			rat mindist(0);
			bool first=true;
			
			
			if (!(valid || other.isValid())) return mindist; //invalid line or region

			point2D::Iterator li=other.getIterator();
			
			while (li.next()){
				poi2D *ti=li.get();
				line2D::Iterator lj=getIterator();
				while(lj.next())
				{
					hseg2D *tj=lj.get();
					if (tj->isLeft())
					{
						if (first)
						{
							mindist=tj->distance(*ti);
							first=false;
						}
						else
						{
							rat temp(tj->distance(*ti));
							if (temp<mindist)
								mindist=temp;
						}
					}
				}
			}

			return mindist;
		}
		
		//returns the minimum distance between this and other
		rat line2D::distance(const line2D &other) const
		{
			//for now implemented as cuadratic
			rat mindist(0);
			bool first=true;
			
			
			if (!(valid || other.isValid())) return mindist; //invalid line 
			
			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D *ti=li.get();
				if (ti->isLeft())
				{
					Iterator lj=other.getIterator();
					while(lj.next())
					{
						hseg2D *tj=lj.get();
						if (tj->isLeft())
						{
							if (first)
							{
								mindist=tj->distance(*ti);
								first=false;
							}
							else
							{
								rat temp(tj->distance(*ti));
								if (temp<mindist)
									mindist=temp;
							}
						}
					}
				}
			}

			return mindist;
		}
		
		bool line2D::isEmpty() const //returns getSize()==0
		{ return (hsegs.count()==0);}

		bool line2D::isValid() const
		{	return valid;	} 
		
// 		int line2D::getType()
// 		{
// 			return LINE2D;
// 		}

		uint line2D::removeHalfSegment(const hseg2D &s)  throw (runtime_error, invalidObjectException)
		{	//returns idx formerly occupied by Hseg removed
					
			if (!s.isValid())
				throw invalidObjectException();

			//int size = hsegs.count();

// 			line2D::Iterator bi=getIterator();
// 			
// 			hseg2D *t;
// 			
// 			if (bi.next()) t=bi.get();
// 			uint loc=FLAGS; //first element is valid flag, so skip
// 			
// 			while (!bi.end() && *t!=s) {
// 				if (bi.next()) {
// 					t=bi.get();
// 					loc++;
// 				}
// 			}
// 			
// 			if (!bi.end())
// 			{
// 				hsegs.remove(loc); //erase s
// 				return loc;
// 			}
// 			else
// 				throw undefinedSpatialObjectException();
			
			
			vectorBinarySearchWrapper< line2D, hseg2D > finder ( this ); 
			
			uint found=0;
			
			if (finder.find(s,found)){
				long loc=static_cast<long>(found)+FLAGS;
				hsegs.remove(loc); //erase s
				return loc;
			}else
			{	//not found
 				throw undefinedSpatialObjectException();
			}	
		}
		

		mbb2D & line2D::getmbb() const 
		{
			if (!valid)
				cerr << "Undefined Object. No MBB Available" << endl;
	
			rat minx(0);
			rat miny(0);
			rat maxx(0);
			rat maxy(0);
			bool first=true;
	
			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D *temp=li.get();
				
				if (first) //first object, assign to all
				{
					minx=(temp->getDominating().getX()<temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					miny=(temp->getDominating().getY()<temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					maxx=(temp->getDominating().getX()>temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					maxy=(temp->getDominating().getY()>temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					first=false;
				}
				else
				{
					rat minsegx=(temp->getDominating().getX()<temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					rat minsegy=(temp->getDominating().getY()<temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					rat maxsegx=(temp->getDominating().getX()>temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					rat maxsegy=(temp->getDominating().getY()>temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
	
					if (minsegx<minx)
						minx=minsegx;
					if (minsegy<miny)
						miny=minsegy;
					if (maxsegx>maxx)
						maxx=maxsegx;
					if (maxsegy>maxy)
						maxy=maxsegy;
				}	
			}
			mbb2D *r=new mbb2D(*(new poi2D(minx,miny)),*(new poi2D(maxx,maxy)));
			return *r;
		}
		
		
		line2D::Iterator line2D::getIterator() const //sorted in half-segment order.		
		{
			line2D::Iterator p(const_cast<line2D*>(this));
			return p;;
		}
		
		//homogeneous ops
		line2D & line2D::intersection( line2D &other)
		{ 
			// find all the overlapping segments
			// use the sweep line to find them
			// then calculate the overlapping parts
			// finally return the line consiting of the 
			// overlapping parts
			block2D allResultSegments;
			vector<block2D> resultBlocks;
			line2D *resultLine = new line2D;
				
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			EventSchedule<line2D, line2D, hseg2D, hseg2D> eventSched( *this, other, dyn1, dyn2 );
			SweepLine<line2D, line2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
				
			hseg2D currentSeg;
			hseg2D aboveSeg;
			hseg2D belowSeg;
			seg2D tempSeg;
			bool aboveExists;
			bool belowExists;
			uint currSegmentCount;
			while(status != end_of_both )
			{
				if( object == both ) currSegmentCount = 2;
				else currSegmentCount = 1;
				
				for( uint i = 0; i < currSegmentCount; i++ )
				{
					if( (i == 0 && object == second) || (i == 1 && object == both) ) {
						sh = statusHseg2D(*(eventSched.i2), 'G');
					}  else {
						sh = statusHseg2D(*(eventSched.i1), 'F');
					}
					
					if(sh.hseg->isLeft())
					{
						// if the insertion results in an intersection
						if( S.add_left_Return_Segs(sh, eventSched, currentSeg, aboveSeg, aboveExists, belowSeg, belowExists ) )
						{
							// find the type of intersection
							// if it is a segment overlap
							// then keep the segment
							if( aboveExists && currentSeg.getSegment().testIntersection( aboveSeg.getSegment() ) == SEGMENT )
							{
								tempSeg = currentSeg.getSegment().seg2DIntersection( aboveSeg.getSegment() );
								allResultSegments.addSegment( tempSeg );
							}
							else if( belowExists && currentSeg.getSegment().testIntersection( belowSeg.getSegment() ) == SEGMENT )
							{
								tempSeg = currentSeg.getSegment().seg2DIntersection( belowSeg.getSegment() );
								allResultSegments.addSegment( tempSeg );	
							}
						}
					}
					else
					{
						//remove from the status struct
						S.del_right(sh, eventSched);
					}
				}
				eventSched.select_next(object, status);
			}	
				
				// now we have all the segments.  time to construct the blocks
				// while there are segments left in the allResultSegments block,
				// keep building new blocks
			breakIntoBlocks( allResultSegments, *resultLine );
			
				
			return *resultLine;
			
		}

		point2D & line2D::common_points( line2D &other)
		{
			vector<block2D> resultBlocks;
			point2D *resultPoint = new point2D();
			
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			EventSchedule<line2D, line2D, hseg2D, hseg2D> eventSched( *this, other, dyn1, dyn2 );
			SweepLine<line2D, line2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
			
			hseg2D currentSeg;
			hseg2D aboveSeg;
			hseg2D belowSeg;
			poi2D tempPoi;
			bool aboveExists;
			bool belowExists;
			uint currSegmentCount;
			
			while(status != end_of_both )
			{
				if( object == both ) currSegmentCount = 2;
				else currSegmentCount = 1;
			
				for( uint i = 0; i < currSegmentCount; i++ )
				{
					if( (i == 0 && object == second) || (i == 1 && object == both) ) {
						sh = statusHseg2D(*(eventSched.i2), 'G');
					}  else {
						sh = statusHseg2D(*(eventSched.i1), 'F');
					}
				
					if(sh.hseg->isLeft())
					{
					// if the insertion results in an intersection
						if( S.add_left_Return_Segs(sh, eventSched, currentSeg, aboveSeg, aboveExists, belowSeg, belowExists ) )
						{
						// find the type of intersection
						// if it is a segment overlap
						// then keep the segment
							if( aboveExists && currentSeg.getSegment().testIntersection( aboveSeg.getSegment() ) == POINT )
							{
								tempPoi = currentSeg.getSegment().poi2DIntersection( aboveSeg.getSegment() );
								resultPoint->addPoint( tempPoi );
							}
							else if( belowExists && currentSeg.getSegment().testIntersection( belowSeg.getSegment() ) == POINT )
							{
								tempPoi = currentSeg.getSegment().poi2DIntersection( belowSeg.getSegment() );
								resultPoint->addPoint( tempPoi );	
							}
						}
					}
					else
					{
					//remove from the status struct
						S.del_right(sh, eventSched);
					}
				}
				eventSched.select_next(object, status);
			}			
			resultPoint->validate();
			return *resultPoint;
		}
		
		line2D & line2D::sunion( line2D &other) 
		{ 		
			// first find all segments in the result line
			// then construct the blocks in the result line by walking
			// segments and finding the connected blocks.
				
			block2D allResultSegments;
			vector<block2D> resultBlocks;
			line2D *resultLine = new line2D;
				
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			EventSchedule<line2D, line2D, hseg2D, hseg2D> eventSched( *this, other, dyn1, dyn2 );
			SweepLine<line2D, line2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
				// during the sweep line algorithm....
				// take every segment that is removed, and keep that as
				// a segment in the resulting regions
			uint currSegmentCount;
			while(status != end_of_both )
			{
				if( object == both ) currSegmentCount = 2;
				else currSegmentCount = 1;
				
				for( uint i = 0; i < currSegmentCount; i++ )
				{
					if( (i == 0 && object == second) || (i == 1 && object == both) ) {
						sh = statusHseg2D(*(eventSched.i2), 'G');
					}  else {
						sh = statusHseg2D(*(eventSched.i1), 'F');
					}
				
					if(sh.hseg->isLeft())
					{
						S.add_left(sh, eventSched);
					}
					else
					{
							//remove from the status struct
						if( S.del_right(sh, eventSched) )
						{
							// record the segment
							allResultSegments.addSegment( sh.hseg->getSegment() );
						}
					}
				}
				eventSched.select_next(object, status);
			}	
				
				// now we have all the segments.  time to construct the blocks
				// while there are segments left in the allResultSegments block,
				// keep building new blocks
			breakIntoBlocks( allResultSegments, *resultLine );
			
				
			return *resultLine;
		}

		line2D & line2D::difference( line2D &other) 
		{ 
			// find all the overlapping segments
			// use the sweep line to find them
			// then calculate the non overlapping parts
			// finally return the line consiting of the 
			// non overlapping parts
			block2D allResultSegments;
			block2D overlappingSegments;
			vectorBinarySearchWrapper< block2D, hseg2D > overlappingSearchWrapper( &overlappingSegments ); 
			uint index;
			vector<block2D> resultBlocks;
			line2D *resultLine = new line2D;
				
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			EventSchedule<line2D, line2D, hseg2D, hseg2D> eventSched( *this, other, dyn1, dyn2 );
			SweepLine<line2D, line2D, hseg2D, hseg2D> S( true );
			statusHseg2D sh;
			eventSched.select_first(object, status);
				
			seg2D currentSeg;
			seg2D aboveSeg;
			seg2D belowSeg;
			seg2D tempSeg;
			hseg2D currenthSeg;
			hseg2D abovehSeg;
			hseg2D belowhSeg;

			bool aboveExists;
			bool belowExists;
			poi2D currP, currQ, otherP, otherQ;
			uint currSegmentCount;
			bool isfirstObject;
			while(status != end_of_both )
			{
				if( object == both )
					currSegmentCount = 2;
				else
					currSegmentCount = 1;
				
				for( uint i = 0; i < currSegmentCount; i++ )
				{
					if( (i == 0 && object == second) || (i == 1 && object == both) )
					{
						sh = statusHseg2D(*(eventSched.i2), 'G');
						isfirstObject = false;
					} 
					else
					{
						sh = statusHseg2D(*(eventSched.i1), 'F');
						isfirstObject = true;
					}
					
					if(sh.hseg->isLeft())
					{
						// if the insertion results in an intersection
						if( S.add_left_Return_Segs(sh, eventSched, currenthSeg, abovehSeg, aboveExists, belowhSeg, belowExists ) )
						{
							// find the type of intersection
							// if it is a segment overlap
							// then keep the non overlapping parts
							currentSeg=currenthSeg.getSegment();
							aboveSeg=abovehSeg.getSegment();
							belowSeg=belowhSeg.getSegment();
							
							if( aboveExists && currentSeg.testIntersection( aboveSeg ) == SEGMENT )
							{
								currP = currentSeg.getP();
								currQ = currentSeg.getQ();
								otherP = aboveSeg.getP();
								otherQ = aboveSeg.getQ();
								
								// now save the intersecting part
								(currP < otherP)? currP = otherP : currP;
								(currQ < otherQ)? currQ : currQ = otherQ;
								tempSeg.setPQ( currP, currQ );
								// tempSeg now holds the overlapping part of the segments
								// save it so that we can not record it in the difference later;
								overlappingSegments.addSegment( tempSeg );
							}
							if( belowExists && currentSeg.testIntersection( belowSeg ) == SEGMENT )
							{
								currP = currentSeg.getP();
								currQ = currentSeg.getQ();
								otherP = belowSeg.getP();
								otherQ = belowSeg.getQ();
								
								// now save the intersecting part
								(currP < otherP)? currP = otherP : currP;
								(currQ < otherQ)? currQ : currQ = otherQ;
								tempSeg.setPQ( currP, currQ );
								// tempSeg now holds the overlapping part of the segments
								// save it so that we can not record it in the difference later;
								overlappingSegments.addSegment( tempSeg );
							}
						}
					}
					else
					{
						//remove from the status struct
						// if this hSeg exists in status struct, and it is not in the 
						// overlapping segments list, then add it to the resutl segments
						if( S.del_right(sh, eventSched) && isfirstObject )
						{
							if( !overlappingSearchWrapper.find( *sh.hseg, index ) )
							{
								allResultSegments.addSegment( sh.hseg->getSegment( ) );
							}
						}
					}
				}
				
				eventSched.select_next(object, status);
			}	
				
				// now we have all the segments.  time to construct the blocks
				// while there are segments left in the allResultSegments block,
				// keep building new blocks
			breakIntoBlocks( allResultSegments, *resultLine );
			
				
			return *resultLine;
			
		}
		
		void line2D::breakIntoBlocks( block2D &allResultSegments, line2D &resultLine )
		{
			// this function takes an invalid block (ie, not connected)
			// and finds all the connected blocks, returning a valid line
			hseg2D currHSeg;
			hseg2D brother;
			uint numVisited = 0;
			vectorBinarySearchWrapper< block2D, hseg2D > blockSearchWrapper( &allResultSegments ); 
			vector<hseg2D> alreadyVisitedVector;
			vectorBinarySearchWrapper< vector<hseg2D>, hseg2D > alreadyVisitedWrapper( &alreadyVisitedVector );
			vector<hseg2D>::iterator itemHseg;
			uint index = 0;
			uint counter = 0;
			while( allResultSegments.size() > 0 )
			{
				counter++;
				block2D newBlock;
					// get an hseg to start walking from
				currHSeg = allResultSegments[0];
				brother.addPoints( currHSeg.getSubmissive(), currHSeg.getDominating(), !currHSeg.isInsideAbove() ); 
					
					// walk the hseg going right from the current hseg
				allResultSegments.walkBlock( currHSeg, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );
					
					// now walk going left from the starting hseg
					
					// remove the startRight and startLeft fromt he already visited vector
					// so we will not stop immediately
					
				if( alreadyVisitedWrapper.find( currHSeg, index) )
				{
					itemHseg = alreadyVisitedVector.begin();
					itemHseg += index;
					alreadyVisitedVector.erase( itemHseg );
				}
				else
				{
						//error, it should be there
					throw runtime_error( " could not find currHseg in already visited list ");
				}
				if( alreadyVisitedWrapper.find( brother, index) )
				{
					itemHseg = alreadyVisitedVector.begin();
					itemHseg += index;
					alreadyVisitedVector.erase( itemHseg );
				}
				else
				{
						//error, it should be there
					throw runtime_error( " could not find brother in already visited list ");
				}
					
					// now walk the opposite direction
				allResultSegments.walkBlock( brother, numVisited, alreadyVisitedWrapper, alreadyVisitedVector, blockSearchWrapper );
	
					// now we have all the hsegs forming a connected block in the alreadyVisitedVector
					// so we make a block out of it:
				for( uint i = 0; i < alreadyVisitedVector.size(); i++ )
				{
					hseg2D tempHSeg = alreadyVisitedVector[i];
					if( tempHSeg.isLeft( ) )
					{
						seg2D tempSeg = tempHSeg.getSegment();
						newBlock.addSegment( tempSeg );
						allResultSegments.removeSegment( tempSeg );
					}
				}
					// now add the block to the new face;
				resultLine.addBlock( newBlock );
				alreadyVisitedVector.clear( );
			}
			cerr<<"num blocks: "<<counter<<endl;
		}
		
// 		//heterogeneous ops
// 		line2D & line2D::intersection(const region2D &other)
// 		{ return *(new line2D());}
// 
// 		line2D & line2D::difference(const region2D &other)
// 		{ return *(new line2D());}
// 		
// 		rat & line2D::distance(const region2D &other)
// 		{ return *(new rat(0));}


////private methods

		Locator line2D::addhseg(const hseg2D &h) throw (invalidObjectException)
		{
			if (!h.isValid())
				throw invalidObjectException("Invalid HalfSegment: Cannot add to line.");
		
			long loc=FLAGS; //skip valid flag which is always the first subelement
			Locator added(false);
			
/*			line2D::Iterator li=getIterator();*/
			
// 			cerr<<"will execute find" << endl;
 			vectorBinarySearchWrapper< line2D, hseg2D > finder ( this ); 
			
			uint found=0;
			
			unsigned char * data=NULL;
			
			if (finder.find(h,found)){
				long loc=static_cast<long>(found);
/*				cerr << "Will locate biatch" << endl;*/
				added=hsegs.locate(loc); //do not add, already there
			}else
			{
				long loc=static_cast<long>(found)+FLAGS;
/*				cout << "Insertion site: " << loc << endl;*/
				uint sp=h.serialSize();
				if (data!=NULL) delete data;
				data=new unsigned char[sp];
				uint len=h.serialize(data);
				
/*				cerr << "Will insert biatch" << endl;*/
				
				added=hsegs.insert(data,len,loc);//add p.
			}	
			
/*			cerr<< "hsegs:"; hsegs.debug();
			cerr<< "blocks:"; blks.debug();
			
			cout << "ths line: " << *this << endl;*/
			if (data!=NULL) delete data;
			
/*			hseg2D *t;	
			
			while (li.next()){
				t=li.get();
				if (*t==h){
					added=hsegs.locate(loc); //do not add, already there
					break;
				}
				if (*t>h){
					uint sp=h.serialSize();
					if (data!=NULL) delete data;
					data=new unsigned char[sp];
					uint len=h.serialize(data);
				
					added=hsegs.insert(data,len,loc);//add p to the end.
					break; //then added here		
				}
				loc++;
			}
			
			if (li.end() && added.isEmpty()){ //reached end so insert last
				uint sp=h.serialSize();
				if (data!=NULL) delete data;
				data=new unsigned char[sp];
				uint len=h.serialize(data);
				added=hsegs.append(data,len);
			}
			
			if (data!=NULL) delete data;
			cerr<< "hsegs:"; hsegs.debug();
			cerr<< "blocks:"; blks.debug();
						
			cout << "ths line: " << *this << endl;*/
			
			return added;
		}

		
		void line2D::removeSegment(const seg2D &s)  throw (undefinedSpatialObjectException)
		{			
			if (s.isUndefined())
				throw undefinedSpatialObjectException();


			hseg2D p(s.getP(),s.getQ(),true);
			hseg2D q(s.getQ(),s.getP(),false);

			removeHalfSegment(p);
			removeHalfSegment(q);
			
// 			line2D::Iterator bi=getIterator();
// 			
// 			hseg2D *t;
// 			
// 			if (bi.next()) t=bi.get();
// 			uint loc=FLAGS; //first element is valid flag, so skip
// 			
// 			while (!bi.end() && *t!=p) 
// 				if (bi.next()) {
// 				t=bi.get();
// 				loc++;
// 				}
// 			
// 				if (!bi.end())
// 				{
// 					hsegs.remove(loc); //erase p
// 					t=bi.get();//once erase, re-get new element at current
// 					while (!bi.end() && *t!=q) 
// 						if (bi.next()) {
// 						t=bi.get();
// 						loc++;
// 						}
// 						if (!bi.end())
// 							hsegs.remove(loc); //erased p, now erase q
// 						else
// 							throw undefinedSpatialObjectException();
// 				}
// 				else
// 					throw undefinedSpatialObjectException();
		}



	
		line2D line2D::delaunayTriangulation()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.triangulation(m_poi_set, reg);
			return reg;
		}


	
		line2D line2D::voronoi()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.voronoi(m_poi_set, reg);
			return reg;
		}
				

		region2D line2D::convexHull()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			region2D reg;
			CConvexHull hull;
			hull.getConvexHull(m_poi_set, reg);
			return reg;
		}
		
	
		
		void line2D::getAllDominates(vector<poi2D>& m_poi_set) 
		{
	
			line2D::Iterator lj=getIterator();
			bool first= true;
			
			while(lj.next())
			{
				hseg2D *tj=lj.get();
				poi2D poi=tj->getDominating();
				if(first){
					m_poi_set.push_back(poi);
					first = false;
				}else{
					/* to compare the last element */
					if(m_poi_set.back()!= poi)
						m_poi_set.push_back(poi);	
				}
			}

		}

		


		
		std::ostream& operator << (std::ostream &ostr, const line2D &rhs) throw( undefinedSpatialObjectException )
		{
			if( !rhs.isValid( ) ) {
				//throw undefinedSpatialObjectException( );
				ostr<< "Invalid line"<<endl ;
			} 	
			//cout << "There are " << rhs.elements.count() << " pois in this point" << endl;
				line2D::Iterator p1=rhs.getIterator();
				hseg2D* pp1;
				ostr << rhs.getSegmentCount() << " segments-> ";
				ostr << "[";
				while (p1.next()){
					pp1=p1.get();
					ostr << ", " << *pp1;
				}
				ostr << "]";
			
			return ostr;
		}

}

