
#include "line2D.h"
#include "region2D.h"
#include "point2D.h"
#include <iostream>
#include "delaunay.h"
#include "convexHull.h"


namespace stu{

	
	using namespace stu;
	using namespace std;
	

	short int point2D::FLAGS=0;
			
	/////////////point iterator methods

	point2D::Iterator::Iterator(){}
	
	point2D::Iterator::Iterator(point2D* par):current(-1), parent(par) {}
	
	bool point2D::Iterator::next(){ 
		if(!end())
			current++;

		return (!end());
	}
	bool point2D::Iterator::prev(){		//added  --Reasey
		if(current>0)
		{
			current--;
			return true;
		}
		else
			return false;
	}
	
	poi2D* point2D::Iterator::get(){
		
//		poi2D temp;
		
		if (current<FLAGS) cerr << "Need to move to next element to retrieve from iterator. " << endl;

// 		cout<<"Current = "<<current<<endl;
		Locator poi(parent->elements.locate(current));

// 		cout<<"Located current\n";
		uint len=poi.length(); //note that length only "really" works if poi is base object...
//		cout << endl << "current poi2D length: " << len << "..."; poi.debug();
//		cout <<  "parent of poi2D: "; parent->elements.debug();
		//cout << "point getted: "; poi.debug();
		unsigned char *buffer=new unsigned char[len];
		uint nread=0; //number of bytes read
		imSlobstream reader=poi.getStream();
		reader.read(buffer,len,nread);
/*		cout << "Buffer read: ";
		cout << *(uint*)buffer << "|";
		cout << *(uint*)(buffer+sizeof(uint)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+sizeof(uint16)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+sizeof(uint16)*2) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+sizeof(uint16)*3) << "|";
		cout << *(uint*)(buffer+sizeof(uint)+sizeof(uint)+sizeof(uint16)*4) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+(sizeof(uint16)*4)+sizeof(uint)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+(sizeof(uint16)*5)+sizeof(uint)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+(sizeof(uint16)*6)+sizeof(uint)) << "|";
		cout << *(uint16*)(buffer+sizeof(uint)+sizeof(uint)+(sizeof(uint16)*7)+sizeof(uint)) << endl; */
		return (new poi2D(buffer,len)); //constructor "deserializes" poi2D object currently in buffer	
			
	}
	
	bool point2D::Iterator::end(){
		return ((current>=(long)parent->elements.count()) || (parent->elements.count()==0));
	}
	bool point2D::Iterator::begin(){		//added  --Reasey
		return (current==static_cast<long>(FLAGS) && parent->elements.count() > static_cast<long>(FLAGS));
	}
	
	point2D::Iterator point2D::Iterator::operator+( int num )
	{
		Iterator temp = *this;
		if (temp.current<FLAGS) temp.current=FLAGS+num; //skip valid flag!
		else temp.current = temp.current+num;
		return temp;
	}
	point2D::Iterator point2D::Iterator::operator-( int num )
	{
		Iterator temp = *this;
		if (temp.current<=FLAGS) 
			temp.current=-1;
		else
			temp.current = temp.current-num;
		return *this;	
	}
	point2D::Iterator point2D::Iterator::operator++( int dummy )
	{
		Iterator temp = *this;
		if (current<FLAGS) current=FLAGS; //skip valid flag!
		else current++;
		return temp;
	}
	point2D::Iterator point2D::Iterator::operator--( int dummy )
	{
		Iterator temp = *this;
		if (temp.current<=FLAGS) 
			temp.current=-1;
		else
			temp.current--;
		return *this;	
	}
	point2D::Iterator& point2D::Iterator::operator+=( int num )
	{
		if (current<FLAGS) current=FLAGS+num; //skip valid flag!
		else current = current+num;
		return *this;
	}
	point2D::Iterator& point2D::Iterator::operator-=( int num )
	{
		current = current - num;
		if( current < FLAGS ) current = FLAGS;
		return *this;
	}
	
	///////////////////////////////////
		
	poi2D point2D::operator[]( uint index )
	{
		point2D::Iterator bIter( this );
		bIter.next( );
		bIter = bIter+index;
		return *bIter.get();
	}
	
	point2D::point2D(bool create):elements(static_cast<bool>(false)), global(create), valid(create)
	{
		if (create)
		{
			//cerr << "Creating empty point" << endl;
			global=global.insert(0, OBJECT_LEVEL); //no need to keep track of root here
			elements=global.insert(0, NONE_LEVEL); //insert primary struct
			//cerr << "Empty Point created" << endl;
		}
	}
	
	point2D::point2D(const Locator& m):
			elements(static_cast<bool>(false)),global(m), valid(true)
	{  //cout << "built with: "; elements.debug();
		if (global.getElements()==0) //then its an empty OBJECT NODE, insert primary struct
		{
			//cout << "Empty Global!" << endl;
//			global=global.insert(0,OBJECT_LEVEL);
			//cout << "Global in p: "; global.debug();
			elements=global.insert(0,NONE_LEVEL);
/*			cout << "Elements in p: "; elements.debug();*/
		}else{
			//cout << "NonEmpty Global!" << endl;
//			global=global.locate(0);
			//cout << "Global in p(2): "; global.debug();
			elements=global.locate(0); //get primary struct		
 			//cout << "Elements in p: "; elements.debug();
		}
	}
	
	point2D::point2D(const Locator& m, const poi2D &p): elements(m.locate(0)), global(m)
	{
		//serialize p, then add to slob
		unsigned char *data=new unsigned char[p.serialSize()];
		uint len=p.serialize(data);
		elements.append(data,len);//add p to the end.
		valid=false; //need to validate
	}
	
	point2D::point2D(const Locator& m, poi2D ps[], uint length):elements(m.locate(0)), global(m)
	{
		for (uint i=0; i<length; i++)
			addPoint(ps[i]);	
	}
	
	point2D::point2D(const Locator& m, const point2D &ps): elements(m.locate(0)), global(m)
	{		
		if (elements.getElements() > 0) //empty first, then copy
			elements.removeAll();
		
		elements.beginBatch();
		//for each poi2D in ps
		for (uint i=0; i<ps.getPointCount(); i++)
		{
			//avoids using iterator in order to not go through unnecessary deserialization/serialization process
			Locator poi(ps.elements.locate(i));
			uint len=poi.length(); //note that length only "really" works if poi is base object...
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=poi.getStream();
			reader.read(buffer,len,nread);
			//now append data just read into new object
			elements.append(buffer,len);
		}
		elements.commitBatch();
		valid=ps.valid;
	}

	point2D::~point2D()
	{
	}
	
	//constructor ops
	void point2D::addPoint(poi2D &p) throw (undefinedSpatialObjectException) //adds point checks it didn't exist already
	{
		if (p.isUndefined()) throw undefinedSpatialObjectException();

		//if there are no elements yet
		if (elements.count()==0){
			uint sp=p.serialSize();
			//cout << "serial size of poi2D " << p << " is: " << sp << endl;
			unsigned char *data=new unsigned char[sp];
			//cout << "will enter serialization" << endl;
			uint len=p.serialize(data);
			//cout << "will append poi2D" << endl;
			elements.append(data,len);//add p to the end.
			valid=true;	
			return;
		}

// 		point2D::Iterator p1=getIterator();
// 		poi2D pp1;
		
		vectorBinarySearchWrapper< point2D, poi2D > finder ( this ); 
			
		uint found=0;
			
		if (finder.find(p,found)){
			return; //do not add, duplicate
		}else
		{
			long loc=static_cast<long>(found);
			uint sp=p.serialSize();
		//cout << "serial size of poi2D " << p << " is: " << sp << endl;
			unsigned char *data=new unsigned char[sp];
		//cout << "will enter serialization" << endl;
			uint len=p.serialize(data);
		//cout << "will insert poi2D at " << loc << endl;
			elements.insert(data,len,loc);//add p to the end.

			valid=true;	
		}	
				
		
// 		uint loc=0;
// 		while (p1.next()){
// 			pp1=*(p1.get());
// 			if (pp1==p)
// 				return; //do not add, duplicate
// 			if (pp1>p)
// 				break; //then add here		
// 			loc++;
// 		}
// 		
// 		uint sp=p.serialSize();
// 		//cout << "serial size of poi2D " << p << " is: " << sp << endl;
// 		unsigned char *data=new unsigned char[sp];
// 		//cout << "will enter serialization" << endl;
// 		uint len=p.serialize(data);
// 		//cout << "will insert poi2D at " << loc << endl;
// 		elements.insert(data,len,loc);//add p to the end.
// 
// 		valid=true;	
	}
	
	void point2D::addPoints(poi2D ps[], uint length) //adds all points
	{
		for (uint i=0; i<length; i++) //&&performance can probably be enhanced
			addPoint(ps[i]);
	}
	
	void point2D::removePoint(const poi2D &p) throw (runtime_error, undefinedSpatialObjectException)//removes a point, no checking needed
	{
		if (p.isUndefined()) throw undefinedSpatialObjectException();

		//uint loc=0;
		vectorBinarySearchWrapper< point2D, poi2D > finder ( this ); 
			
		uint found=0;
			
		if (finder.find(p,found)){
			long loc=static_cast<long>(found);
			elements.remove(loc);
			return; //do not add, duplicate
		}else
		{
			return; //poi2D not found
		}
				
		
/*		while (p1.next()){
			pp1=*(p1.get());
			if (pp1==p){
//				cout << "Will remove " << pp1 << " at index " << loc << endl;
				//elements.myslob->sinx->debug();
				elements.remove(loc);
//				cout << "Removed" << endl;
				//elements.myslob->sinx->debug();
				//cout << "Element found!" << endl;
				return; //found, so eliminate duplicate
			}
			if (pp1>p)
				break; //not found
			loc++;
		}

		return; //poi2D not found*/
	} 

	const uint point2D::getPointCount() const //returns the size/number of points
	{
		return elements.count();
	}
	
	uint point2D::size() const
	{
		return getPointCount();
	}
	
	bool point2D::isEmpty() const//returns getSize()==0
	{
		return (elements.count()==0);
	}
	
	bool point2D::validate()
	{
		valid=true;
		unsigned char *buffer1=NULL;
		unsigned char *buffer2=NULL;
		//just make sure no two points are equal
		if (elements.count()>0)
		{
			for (uint i=0; i<elements.count()-1; i++){
				Locator poi(elements.locate(i));
				uint len=poi.length(); //note that length only "really" works if poi is base object...
				if (buffer1!=NULL) delete buffer1;
				buffer1=new unsigned char[len];
				uint nread=0; //number of bytes read
				imSlobstream reader=poi.getStream();
				reader.read(buffer1,len,nread);
				//construct temporary poi2D to compare
				poi2D *temp=new poi2D(buffer1,len); //constructor "deserializes" poi2D object currently in buffer	
				
				Locator poi2(elements.locate(i+1));
				len=poi.length(); //note that length only "really" works if poi is base object...
				if (buffer2!=NULL) delete buffer2;
				buffer2=new unsigned char[len];
				nread=0; //number of bytes read
				imSlobstream reader2=poi.getStream();
				reader2.read(buffer2,len,nread);
				//construct temporary poi2D to compare
				poi2D *temp2=new poi2D(buffer2,len); //constructor "deserializes" poi2D object currently in buffer	
				
				if (temp==temp2) //duplicate found, invalidate
				{
					delete temp;
					delete temp2;
					valid=false;
					break;
				}
			}
		}
		//cout << "All valid to me!" << endl;
		return valid;
	}

	bool point2D::isValid() const
	{
		return valid;
	}

	point2D::Iterator point2D::getIterator() const
	{
		point2D::Iterator p(const_cast<point2D*>(this));
		return p;
	}
	
	mbb2D point2D::getmbb() const 
	{
		if (!valid)
			cerr << "Undefined Object. No MBB Available" << endl;

		rat minx(0);
		rat miny(0);
		rat maxx(0);
		rat maxy(0);
		bool first=true;

		point2D::Iterator p1=getIterator();
		poi2D temp;
		
		while (p1.next()){
			temp=*(p1.get());
//			cout<<"Got current\n";
/*			cout << "TempValues: " << temp.getX() << ", " << temp.getY() << endl;*/
			if (first) //first object, assign to all
			{
				minx=temp.getX();
				miny=temp.getY();
				maxx=temp.getX();
				maxy=temp.getY();
				first=false;
			}
			else {
				if (temp.getX()<minx)
					minx=temp.getX();
				if (temp.getY()<miny)
					miny=temp.getY();
				if (temp.getX()>maxx)
					maxx=temp.getX();
				if (temp.getY()>maxy)
					maxy=temp.getY();
			}
/*			cout << "CurrValues: " << minx << ", " << miny << ", "<< maxx<<", "<< maxy << endl;*/
		}
/*		mbb2D *r=new mbb2D(*(new poi2D(minx,miny)),*(new poi2D(maxx,maxy)));
		return *r;*/
//		cout<<"built mbb\n";
		return  mbb2D(poi2D(minx,miny),poi2D(maxx,maxy));
	}
	
	//homogeneous ops
	point2D point2D::intersection(const point2D &other) const 
	{ 
		point2D inter; //= new point2D(); //resulting set, initially empty

		point2D::Iterator p1=this->getIterator();
		point2D::Iterator p2=other.getIterator();

		poi2D pp1,pp2;
		
		//move to first element
		if (p1.next()) pp1=*(p1.get());
		if (p2.next()) pp2=*(p2.get());
		
		while (!p1.end() && !p2.end())
		{
			if (pp1==pp2)//part of the intersection set
			{
				//cout << "Will add: " << pp1 << endl;
				inter.addPoint(pp1);
				if (p1.next()) pp1=*(p1.get());
				if (p2.next()) pp2=*(p2.get());
			}
			else {
				if (pp1<pp2){
					if (p1.next()) pp1=*(p1.get());
				}
				else if (p2.next()) pp2=*(p2.get());
			}
		}
		return (inter);
	}

	point2D point2D::sunion(const point2D &other) const 
	{
		point2D uni; //resulting set, initially empty

		point2D::Iterator p1=this->getIterator();
		point2D::Iterator p2=other.getIterator();

		poi2D pp1,pp2;
		
		//move to first element
		if (p1.next()) pp1=*(p1.get());
		if (p2.next()) pp2=*(p2.get());
		
		while (!p1.end() ||  !p2.end())
		{
			if (!p1.end() && !p2.end() && pp1==pp2)//part of the intersection set, so add once
			{
				//cout << "Will add: " << pp1 << endl;
			//	cerr << "Adding " << pp1 <<  endl;
				uni.addPoint(pp1);
			//	cerr << "Done" << endl;
				if (p1.next()) pp1=*(p1.get());
				if (p2.next()) pp2=*(p2.get());
			}
			else {
			//	cout << "Adding " << pp1 << endl;
				if (!p1.end()) uni.addPoint(pp1);
			//	cerr << "Done" << endl;
			//	cerr << "Adding " << pp2 << endl;
				if (!p2.end()) uni.addPoint(pp2);
			//	cerr << "Done" << endl;
				if (p1.next()) pp1=*(p1.get());
				if (p2.next()) pp2=*(p2.get());
			}
		}
		return (uni);
	}	

	point2D point2D::difference(const point2D &other) const 
	{
		point2D diff; //resulting set, initially empty
		
		point2D::Iterator p1=this->getIterator();
		point2D::Iterator p2=other.getIterator();

		poi2D pp1,pp2;
		
		//move to first element
		if (p1.next()) pp1=*(p1.get());
		if (p2.next()) pp2=*(p2.get());

		while (!p1.end() &&  !p2.end())
		{
			if (pp1==pp2)//part of the intersection set
			{
				if (p1.next()) pp1=*(p1.get());
				if (p2.next()) pp2=*(p2.get());
			}
			else {
				if (pp1< pp2)
				{ 
					diff.addPoint(pp1);					
					if (p1.next()) pp1=*(p1.get());
				}
				else 
				{ 
					if (p2.next()) pp2=*(p2.get());
				}
			}
		}

		//finished while, now check if there are leftovers
		while (!p1.end())
		{ 
			diff.addPoint(pp1);					
			if (p1.next()) pp1=*(p1.get());
		}
			
		return (diff);
		
	}
	
	rat point2D::distance(const point2D &other) const //returns the minimum distance
	{
		rat *min=NULL;
		rat one(1);
		
		point2D::Iterator p1=this->getIterator();
		poi2D pp1;
		
		rat *temp=NULL;
		
		while (!p1.end()){
			if (p1.next()) pp1=*(p1.get());
			point2D::Iterator p2=other.getIterator();
			poi2D pp2;
			if (p2.next()) pp2=*(p2.get());
			while (!p2.end()){
				if (min==NULL)
					min=new rational(pp1.distance(pp2));
				else {
					temp=new rational(pp1.distance(pp2));
					if ((*temp)<(*min)){
						delete min; //old min
						min=temp;
					}
				}
				if (p2.next()) pp2=*(p2.get());
			}
		}
		return (*min);
	}





		line2D point2D::delaunayTriangulation()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.triangulation(m_poi_set, reg);
			return reg;
		}

		line2D point2D::voronoi()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.voronoi(m_poi_set, reg);
			return reg;
		}
	

		region2D point2D::convexHull()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			region2D reg;
			CConvexHull hull;
			hull.getConvexHull(m_poi_set, reg);
			return reg;
		}
		
	
		
		void point2D::getAllDominates(vector<poi2D>& m_poi_set) 
		{
	
			point2D::Iterator lj=getIterator();
			bool first= true;
			
			while(lj.next())
			{
				//hseg2D *tj=lj.get();
				poi2D poi=*(lj.get());
				if(first){
					m_poi_set.push_back(poi);
					first = false;
				}else{
					/* to compare the last element */
					if(m_poi_set.back()!= poi)
						m_poi_set.push_back(poi);	
				}
			}

		}





	
	//heterogeneous ops
// 	point2D& point2D::intersection(const line2D &other)const {return *(new point2D(*this));}
// 	point2D& point2D::intersection(const region2D &other)const {return *(new point2D(*this));}
// 	point2D& point2D::difference(const line2D &other)const {return *(new point2D(*this));}
// 	point2D& point2D::difference(const region2D &other)const {return *(new point2D(*this));}
// 	
// 	rat &point2D::distance(const line2D &other)const {return *(new rat(1));}
// 	rat &point2D::distance(const region2D &other)const {return *(new rat(1));}
	
	std::ostream& operator << (std::ostream &ostr, const point2D &rhs) throw( undefinedSpatialObjectException )
	{
		if( !rhs.isValid( ) ) {
			throw undefinedSpatialObjectException( );
			ostr<< "Undefined" ;
		} else {	
			//cout << "There are " << rhs.elements.count() << " pois in this point" << endl;
			point2D::Iterator p1=rhs.getIterator();
			poi2D pp1;
		
			ostr << "[";
			while (p1.next()){
				pp1=*(p1.get());
				ostr << ", " << pp1;
			}
			ostr << "]";
		}
		return ostr;
	}

}

