create or replace library point_lib as '/var/opt/oracle/product/10.2.0.1/lib/tpoints.so'; 
/

CREATE or replace PACKAGE point_pkg AS  
   function point_getCount(b blob) return pls_integer;
END;
/

create or replace package body point_pkg as
	function point_getCount(b blob) return pls_integer 
	as external
	language C WITH CONTEXT
	name "point_getCount"
	library POINT_LIB 
	parameters(CONTEXT, b OCILobLocator); 
end;
/

create or replace type point2D as Object (
	pdata blob,
		member function getCount 	return pls_integer	
);
/

create or replace type body point2D is
		member function getCount 	return pls_integer is
			num pls_integer := point_pkg.point_getCount(pdata);
			BEGIN
				return num;
			END;
end;
/

create table testpoint(
	id integer primary key,
	pointy point2D
);

select id, point2D.getCount(pointy) from testpoint;