#include "region2D.h"

#define min(a,b)=(a<b?a:b)
#define max(a,b)=(a>b?a:b)
#include "Algorithm_rr.h"

namespace stu{
	
		using namespace stu;
		
		short int region2D::FLAGS=1;
		
		struct poiSeg{
			poi2D p;
			long loc;
					
			poiSeg():p(),loc(-1){}
			poiSeg(const poiSeg& rhs):p(rhs.p),loc(rhs.loc){}
			poiSeg& operator=(const poiSeg& rhs)
			{
				p=rhs.p;
				loc=rhs.loc;
				return *this;	
			}
					
			bool operator==(const poiSeg& rhs) const{ return (p==rhs.p);}
			bool operator<(const poiSeg& rhs) const { return (p<rhs.p);}
		};

	
		////////////region iterator methods
		region2D::Iterator::Iterator(){}
		region2D::Iterator::Iterator(region2D* par):current(-1), parent(par) {}
	
		bool region2D::Iterator::next(){ 
			if (current<0) current=FLAGS; //skip valid flag!
			else current++;
			return (!end());
		}
		bool region2D::Iterator::prev(){		//added  --Reasey
			if(current>FLAGS)
			{
				current--;
				return true;
			}
			else
				return false;
		}
		hseg2D* region2D::Iterator::get(){
		
			if (current<0) throw runtime_error("Need to move to next element to retrieve from iterator. ");
		
			Locator hseg(parent->hsegs.locate(current));
			uint len=hseg.length(); //note that length only "really" works if hseg is base object...
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=hseg.getStream();
			reader.read(buffer,len,nread);
			hseg2D *temp=new hseg2D(buffer,len); //constructor "deserializes" hseg2D object currently in buffer	
			
			return temp;
		}
		
		bool region2D::Iterator::begin(){	//added  --Reasey, modified Ale
			return (current==FLAGS && (long)(parent->hsegs.count()) > FLAGS);
		}
		
		bool region2D::Iterator::end(){
			//take into account that first element should always be valid flag
			return (current>static_cast<long>(parent->hsegs.count())-1 || static_cast<long>(parent->hsegs.count())<=FLAGS);
		}
	
		region2D::Iterator region2D::Iterator::operator+( int num )
		{
			Iterator temp = *this;
			if (temp.current<FLAGS) temp.current=FLAGS+num; //skip valid flag!
			else temp.current = temp.current+num;
			return temp;
		}
		region2D::Iterator region2D::Iterator::operator-( int num )
		{
			Iterator temp = *this;
			temp.current = temp.current-num;
			if (temp.current<FLAGS) temp.current=FLAGS; //skip valid flag!
			return temp;	
		}
		region2D::Iterator region2D::Iterator::operator++( int dummy )
		{
			Iterator temp = *this;
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			else current++;
			return temp;
		}
		region2D::Iterator region2D::Iterator::operator--( int dummy )
		{
			Iterator temp = *this;
			current--;
			if (current<FLAGS) current=FLAGS; //skip valid flag!
			return temp;
		}
		region2D::Iterator& region2D::Iterator::operator+=( int num )
		{
			if (current<FLAGS) current=FLAGS+num; //skip valid flag!
			else current = current+num;
			return *this;
		}
		region2D::Iterator& region2D::Iterator::operator-=( int num )
		{
			current = current - num;
			if( current < FLAGS ) current = FLAGS;
			return *this;
		}
		
		///////////////////////////////////
		
		hseg2D region2D::operator[]( uint index )
		{
			region2D::Iterator pIter( this );
			pIter.next( );
			pIter = pIter+index;
			return *pIter.get();
		}
		
		uint region2D::size() const
		{
			return (hsegs.count()-FLAGS);
		}		
		
		
		void region2D::loadValid(){
			changed=false;
			Locator flg(hsegs.locate(0));
			uint len=flg.length(); //the flag length should be 1!
			unsigned char *buffer=new unsigned char[len];
			uint nread=0; //number of bytes read
			imSlobstream reader=flg.getStream();
			reader.read(buffer,len,nread);
			valid=(*buffer=='V');
/*			cout << "Buvalid: " << buffer[0] << endl;*/
		}

		void region2D::saveValid(){
			if (changed){
// 				cout << "Save valid= " << valid << endl;
				if (hsegs.count()>0) hsegs.remove(0);
				unsigned char *buffer=new unsigned char;
				if (valid) *buffer='V'; 
				else *buffer='I';
				hsegs.insert(buffer,1,0);
			}
			changed=false;
		}

		region2D::region2D(bool create):global(create), hsegs(false), faces(false), valid(false), changed(create), inBatch(false){
			if (create)
			{
				global=global.insert(0,OBJECT_LEVEL); //move global one level down OBJECT_LEVEL
				hsegs=global.insert(0,NONE_LEVEL); //insert primary structure
				faces=global.insert(1,NONE_LEVEL); //insert secondary structure
				saveValid();
			}
		}
		
		region2D::region2D(const Locator& m):global(m), hsegs(false), faces(false), valid(false), changed(true), inBatch(false) {
//			cout << "Global count: " << global.count() << endl;
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				faces=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				faces=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				validate();
				//saveValid(); //first save
			
			cout << "Loaded Region: " << valid << endl;
/*			for (uint i=0; i<faces.count(); i++){
				cout << "Face? : " << i <<" -- "; faces.locate(i).debug();
			}*/
/*			global.getMySlob()->sinx->debug();	*/
		}
		
		region2D::region2D(const Locator& m, const face2D &b):global(m),hsegs(false), faces(false), valid(false),changed(true), inBatch(false){		
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				faces=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				faces=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				validate();
				//saveValid(); //first save

			addFace(b);
		}

		region2D::region2D(const Locator& m, const face2D bs[], uint length):global(m), hsegs(false), faces(false),valid(false), changed(true), inBatch(false)
		{
			if (global.getElements()==0){
				hsegs=global.insert(0,NONE_LEVEL);
				faces=global.insert(1,NONE_LEVEL);
			}
			else{ //already there
				hsegs=global.locate(0);
				faces=global.locate(1);
			}

			if (hsegs.count()>0)
				loadValid();
			else
				validate();
				//saveValid(); //first save

			addFaces(bs,length);
		}
		
		region2D::region2D(const Locator& m, const region2D &ls):global(m), hsegs(false), faces(false), valid(ls.valid), changed(ls.valid), inBatch(false) {
			//copy region2D ls as a whole....no need to go element by element
		}
		
		region2D::~region2D(){}
		
		//constructor ops
		face2D region2D::addFace(const face2D &b)
		{	//b should be from a different mSLob, so copy it
			
			uint cid=faces.count();
			
			Locator newfacel(faces.insert(cid,NONE_LEVEL));
			
			//first copy flags so that they are not created new upon loading
			for (uint i=0 ; i<face2D::FLAGS; i++){
				Locator flg(b.elements.locate(i));
				uint len=flg.length(); //the flag length should be 1!
				unsigned char *buffer=new unsigned char[len];
				uint nread=0; //number of bytes read
				imSlobstream reader=flg.getStream();
				reader.read(buffer,len,nread);
				newfacel.insert(buffer,len,i);	
				delete buffer;
			}
			
			newfacel.insert(face2D::FLAGS,NONE_LEVEL); //add hsegs
			newfacel.insert(face2D::FLAGS+1,NONE_LEVEL); //add polys
			
			face2D newface(*this,newfacel);
			
			face2D::PolyIterator b1=b.getPolyIterator(); //this iterates over polys in face
			poly2D* p;

			
			while (b1.next()){
				p=b1.get();
				if (p->isOuterCycle())
					newface.addOuterCycle(*p);
				else
					newface.addHole(*p);
			}
	
			//toReturn->parent=this;

			invalidate(); //invalidate the region now that a new face has been added

			return newface;
		}
		
 		face2D region2D::addFace()
		{	//create new empty block and return it

			//no need to invalidate as new empty block does nothing wrong
			Locator newface(faces.insert(faces.count(),NONE_LEVEL));
			
			face2D toReturn(*this, newface);
//			toReturn->parent=this;
// 			invalidate();

			// 			cout << "Added empty face! "; newface.debug();
			
			return toReturn;
		}
		
		
		//adds all blocks, leaves checking to validate
		void region2D::addFaces(const face2D bs[], uint length) throw (invalidObjectException)
		{
			inBatch=true;
			for (uint i=0; i<length; i++)
				addFace(bs[i]);
			inBatch=false;
			invalidate();
		}
		
		face2D region2D::getFace(uint idx){ //returns the idx block of this line
			if (idx<faces.count())
				return face2D(*this,faces.locate(idx));
			else{
				throw runtime_error("Invalid face index!");
			}
		}
		
		bool region2D::removeFace(uint idx)
		{
			//face2D up(global, faces.locate(idx));
			face2D up(*this, faces.locate(idx));
/*			cout << "The face to remove: "; faces.locate(idx).debug();*/
			//now strongRemove all segments associated to this block
/*			face2D::PolyIterator bi=up.getPolyIterator();*/
			//poly2D* e;
			//hseg2D* t=NULL;
			//uint cur=0;
			
/*			cout <<"about to delete stuff" << endl;
			global.getMySlob()->sinx->debug();*/
			//remove all polys in face
			for (uint i=0; i<up.getHoleCount(); i++)
				up.removeHole(i+1); //skip outer cycle
			
			up.removeOuterCycle();
/*			cout << "deleted outer cycle" << endl;
			global.getMySlob()->sinx->debug();*/
			
/*			cout << "will delete flag:"; up.elements.locate(0).debug();*/
			while (up.elements.count()>0) //remove flag and parent subobjects
				if (!up.elements.remove(0))
					return false;

/*			global.getMySlob()->sinx->debug();*/
/*			cout << "removed flag, will remove the face" << endl;*/
			
/*			global.getMySlob()->sinx->debug();*/
			
// 			cout << "Global: "; global.debug();
// 			cout << "HSegs: "; hsegs.debug();
// 			cout << "Faces: "; faces.debug();
			return faces.remove(idx); //should be empty by now; 
		}

		bool region2D::validate()
		{
			if (!valid){
				
// 				cerr << "Validating region!" << endl;
				
				//first check that all the children are valid
				for  (uint i=0; i<faces.count(); i++)
				{	
					face2D temp(*this, faces.locate(i));
					if (!temp.isValid()) //if its not valid, then try to validate
						if (!temp.validate()) 
						{
							cerr << "Attempt to validate face FAILED." << endl;
							return false;
						}
				}
				
				if (hsegs.count()>0){
					
					// check intersection of segments and agreement on insideAbove flags (exactly as in faces)
					whichObj object;
					whatStatus status;
					dvector<hseg2D> dyn1;
					dvector<hseg2D> dyn2;
					region2D tempPl;
					EventSchedule<region2D, region2D, hseg2D, hseg2D> eventSched( *this, tempPl, dyn1, dyn2 );
					SweepLine<region2D, region2D, hseg2D, hseg2D> S( true );
					statusHseg2D sh;
					eventSched.select_first(object, status);
					hseg2D segCurr, segAbove, segBelow;
					bool aboveExists, belowExists;
					
					while(status != end_of_both )
					{
						//cout << "Looking" << endl;
						if(object == first || object == both )
						{
							sh = statusHseg2D(*(eventSched.i1), 'F');
							if(eventSched.i1->isLeft())
							{
								bool inter=S.add_left_Return_Segs( sh, eventSched, segCurr, segAbove, aboveExists, segBelow, belowExists );
								if( inter ) //then there is an intersection
								{
									cerr<<"Not a valid region: intersecting segments"<<endl;
									return false;
								}else //no intersection, check ia of segs above and below
								{
									hseg2D next;
									if (eventSched.look_aheadF(&segCurr,next)){
										if (next.getDominating()==segCurr.getDominating()){
											segAbove=next;
											aboveExists=true;
										}
										//cout << "Looked ahead: " << next << endl;
									}
									
									if (aboveExists && segCurr.isInsideAbove()==segAbove.isInsideAbove()) //then error
									{
										cerr << "InsideAbove(region) does not match with above segment. Curr: " << segCurr << " Above: " << segAbove << endl;
										return false;
									}
										
									if (belowExists && segCurr.isInsideAbove()==segBelow.isInsideAbove()) //then error
									{
										cerr << "InsideAbove(region) does not match with below segment. Curr: " << segCurr << " Above: " << segBelow << endl;
										return false;
									}
								}
							}
							else
							{
								S.del_right(sh, eventSched);
							}
						}
						eventSched.select_next(object, status);
					}
				}
				
				valid=true;
				changed=true;
				saveValid();
			}
			return valid;
 		}
		
		uint region2D::getSegmentCount() const //returns the number of segments for the whole line
		{ return ((hsegs.count()-1)/2);} //dont count valid flag

		uint region2D::getFaceCount() const//number of blocks
		{
			return faces.count();
		}

		rat region2D::getLength() const //returns the perimeter. sum of lenghts of segments
		{ 
			//because every segment is stored twice, then sum all hseg lengths and divide by 2.
			rat tlength(0);

			if (!valid) return *(new rat(tlength));; //invalid line has length of 0

			Iterator li=getIterator();
			hseg2D* t;
			
			while (li.next()){
				t=li.get();
				if (t->isLeft()) tlength+=t->getLength();
			}

			return tlength;
		}

		bool region2D::isEmpty() const //returns getSize()==0
		{ return (hsegs.count()==0);}

		bool region2D::isValid() const
		{	return valid;	} 
		
// 		int region2D::getType()
// 		{
// 			return LINE2D;
// 		}


		mbb2D region2D::getmbb() const 
		{
			if (!valid)
				throw runtime_error("Invalid Object. No MBB Available");
	
			rat minx(0);
			rat miny(0);
			rat maxx(0);
			rat maxy(0);
			bool first=true;
	
			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D* temp=li.get();
				
				if (first) //first object, assign to all
				{
					minx=(temp->getDominating().getX()<temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					miny=(temp->getDominating().getY()<temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					maxx=(temp->getDominating().getX()>temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					maxy=(temp->getDominating().getY()>temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					first=false;
				}
				else
				{
					rat minsegx=(temp->getDominating().getX()<temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					rat minsegy=(temp->getDominating().getY()<temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
					rat maxsegx=(temp->getDominating().getX()>temp->getSubmissive().getX()?temp->getDominating().getX():temp->getSubmissive().getX());
					rat maxsegy=(temp->getDominating().getY()>temp->getSubmissive().getY()?temp->getDominating().getY():temp->getSubmissive().getY());
	
					if (minsegx<minx)
						minx=minsegx;
					if (minsegy<miny)
						miny=minsegy;
					if (maxsegx>maxx)
						maxx=maxsegx;
					if (maxsegy>maxy)
						maxy=maxsegy;
				}	
			}
			mbb2D r(poi2D(minx,miny),poi2D(maxx,maxy));
			return r;
		}
		
		
		region2D::Iterator region2D::getIterator() const //sorted in half-segment order.		
		{
			region2D::Iterator p(const_cast<region2D*>(this));
			return p;
		}
		 
				//returns the minimum distance between this and other
		rat region2D::distance(const point2D &other) const 
		{
			//for now implemented as cuadratic
			rat mindist(0);
			bool first=true;
			
			
			if (!(valid || other.isValid())) return mindist; //invalid line or region

			point2D::Iterator li=other.getIterator();
			
			while (li.next()){
				poi2D *ti=li.get();
				region2D::Iterator lj=getIterator();
				while(lj.next())
				{
					hseg2D *tj=lj.get();
					if (tj->isLeft())
					{
						if (first)
						{
							mindist=tj->distance(*ti);
							first=false;
						}
						else
						{
							rat temp(tj->distance(*ti));
							if (temp<mindist)
								mindist=temp;
						}
					}
				}
			}

			return mindist;
		}
		
			//returns the minimum distance between this and other
		rat region2D::distance(const line2D &other) const
		{
			//for now implemented as cuadratic
			rat mindist(0);
			bool first=true;
			
			
			if (!(valid || other.isValid())) return mindist; //invalid line or region

			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D *ti=li.get();
				if (ti->isLeft())
				{
					line2D::Iterator lj=other.getIterator();
					while(lj.next())
					{
						hseg2D *tj=lj.get();
						if (tj->isLeft())
						{
							if (first)
							{
								mindist=tj->distance(*ti);
								first=false;
							}
							else
							{
								rat temp(tj->distance(*ti));
								if (temp<mindist)
									mindist=temp;
							}
						}
					}
				}
			}

			return mindist;
		}
		
		//returns the minimum distance between this and other
		rat region2D::distance(const region2D &other) const 
		{
			//for now implemented as cuadratic
			rat mindist(0);
			bool first=true;
			
			
			if (!(valid || other.isValid())) return mindist; //invalid line or region

			Iterator li=getIterator();
			
			while (li.next()){
				hseg2D *ti=li.get();
				if (ti->isLeft())
				{
					Iterator lj=other.getIterator();
					while(lj.next())
					{
						hseg2D *tj=lj.get();
						if (tj->isLeft())
						{
							if (first)
							{
								mindist=tj->distance(*ti);
								first=false;
							}
							else
							{
								rat temp(tj->distance(*ti));
								if (temp<mindist)
									mindist=temp;
							}
						}
					}
				}
			}

			return mindist;
		}		
// 		//heterogeneous ops
// 		region2D & region2D::intersection(const region2D &other)
// 		{ return *(new region2D());}
// 
// 		region2D & region2D::difference(const region2D &other)
// 		{ return *(new region2D());}
// 		
// 		rat & region2D::distance(const region2D &other)
// 		{ return *(new rat(0));}


////private methods

		Locator region2D::addhseg(const hseg2D &h) throw (invalidObjectException)
		{
			if (!h.isValid())
				throw invalidObjectException();
		
//			Iterator li=getIterator();
//			uint loc=FLAGS; //skip valid flag which is always the first subelement
			Locator added(false);
			
			unsigned char *data=NULL;
//			hseg2D *t;
			
			vectorBinarySearchWrapper< region2D, hseg2D > finder ( this ); 
			
			uint found=0;
			
			if (finder.find(h,found)){
				long loc=static_cast<long>(found)+FLAGS;
 				added=hsegs.locate(loc); //do not add, already there
				//return added; //do not add, duplicate
			}else
			{
				long loc=static_cast<long>(found)+FLAGS;
				uint sp=h.serialSize();
				if (data!=NULL) delete data;
				data=new unsigned char[sp];
				uint len=h.serialize(data);
				
				added=hsegs.insert(data,len,loc);//add h
			}	
							
// 			while (li.next()){
// 				t=li.get();
// 				if (*t==h){
// 					added=hsegs.locate(loc); //do not add, already there
// 					break;
// 				}
// 				if (*t>h){
// 					uint sp=h.serialSize();
// 					if (data!=NULL) delete data;
// 					data=new unsigned char[sp];
// 					uint len=h.serialize(data);
// 				
// 					added=hsegs.insert(data,len,loc);//add p to the end.
// 					break; //then added here		
// 				}
// 				loc++;
// 			}
// 			
// 			if (li.end() && added.isEmpty()){ //reached end so insert last
// 				uint sp=h.serialSize();
// 				if (data!=NULL) delete data;
// 				data=new unsigned char[sp];
// 				uint len=h.serialize(data);
// 				added=hsegs.append(data,len);
// 			}
			
// 			cout << "Added at region2D: "; added->debug();
// 			cout << "GLOBAL: "; global.debug();
// 			cout << "HSEGS: "; hsegs.debug();
// 			cout << "BLKS: "; blks.debug();
			if (data!=NULL) delete data;
// 			cout << "Added hseg to region, hsegs: "; hsegs.debug();
			return added;
		}

		
		void region2D::removeSegment(const seg2D &s)  throw (undefinedSpatialObjectException)
		{			
			if (s.isUndefined())
				throw undefinedSpatialObjectException();


			hseg2D p(s.getP(),s.getQ(),true);
			hseg2D q(s.getQ(),s.getP(),false);
			//int size = hsegs.count();

			region2D::Iterator bi=getIterator();
			
			hseg2D *t;
			
			if (bi.next()) t=bi.get();
			uint loc=1; //first element is valid flag, so skip
			
			while (!bi.end() && *t!=p){
				if (bi.next()) {
				t=bi.get();
				loc++;
				}
			}
			
			if (!bi.end())
			{
				hsegs.remove(loc); //erase p
				t=bi.get();//once erase, re-get new element at current
				while (!bi.end() && *t!=q) 
					if (bi.next()) {
					t=bi.get();
					loc++;
					}
					if (!bi.end())
						hsegs.remove(loc); //erased p, now erase q
					else
						throw undefinedSpatialObjectException();
			}
			else
				throw undefinedSpatialObjectException();
		}
		
		uint region2D::removeHalfSegment(const hseg2D &s)  throw (invalidObjectException)
		{	//returns idx formerly occupied by Hseg removed
					
			if (!s.isValid())
				throw invalidObjectException();

			//int size = hsegs.count();

// 			region2D::Iterator bi=getIterator();
// 			
// 			hseg2D *t;
// 			
// 			if (bi.next()) t=bi.get();
// 			uint loc=1; //first element is valid flag, so skip
// 			
// 			while (!bi.end() && *t!=s) {
// 				if (bi.next()) {
// 					t=bi.get();
// 					loc++;
// 				}
// 			}
// 			
// 			if (!bi.end())
// 			{
// 				hsegs.remove(loc); //erase s
// 				return loc;
// 			}
// 			else
// 				throw undefinedSpatialObjectException();
			
			vectorBinarySearchWrapper< region2D, hseg2D > finder ( this ); 
			
			uint found=0;
			
			if (finder.find(s,found)){
				long loc=static_cast<long>(found)+FLAGS;
				hsegs.remove(loc); //erase s
				return loc;
			}else
			{	//not found
				throw undefinedSpatialObjectException();
			}
		}
		
		void region2D::invalidate(){
			if (valid){
				valid=false;
				changed=true;
				if (!inBatch) saveValid();
			}
		}
		
		rat region2D::getArea() const
		{
			if (valid){
				
				if (hsegs.count()>0){
					
					// check intersection of segments and agreement on insideAbove flags (exactly as in faces)
					whichObj object;
					whatStatus status;
					dvector<hseg2D> dyn1;
					dvector<hseg2D> dyn2;
					region2D tempPl;
					EventSchedule<region2D, region2D, hseg2D, hseg2D> eventSched( *const_cast<region2D*>(this), tempPl, dyn1, dyn2 );
					SweepLine<region2D, region2D, hseg2D, hseg2D> S( true );
					statusHseg2D sh;
					eventSched.select_first(object, status);
					hseg2D segCurr, segAbove, segBelow;
					bool aboveExists, belowExists;
					rat currArea(0);
					rat two(2);
					
					while(status != end_of_both )
					{
						//cout << "Looking" << endl;
						if(object == first || object == both )
						{
							sh = statusHseg2D(*(eventSched.i1), 'F');
							if(eventSched.i1->isLeft())
							{
								S.add_left_Return_Segs( sh, eventSched, segCurr, segAbove, aboveExists, segBelow, belowExists );
								
								//area of current trapezoid ((x2-x1) * (y2+y1) / 2)
								
								rat temp=((segCurr.getSubmissive().getX()-segCurr.getDominating().getX()) * (segCurr.getSubmissive().getY()+segCurr.getDominating().getY())) / two;
								
								if (segCurr.isInsideAbove())
									temp=temp.neg();
								
								currArea+=temp;
							}
							else
							{
								S.del_right(sh, eventSched);
							}
						}
						eventSched.select_next(object, status);
					}
					
					return currArea;
					
				}else return rat(0); //no segs, area of 0
				
			}
			return rat(0); //invalid region has area of 0
		}
		
		hseg2D findBrother(dvector<hseg2D> segs, const hseg2D& cur, long& loc)
		{
			vectorBinarySearchWrapper< dvector<hseg2D>, hseg2D > polySearchWrapper( &segs ); 
			
			uint found=0;
			hseg2D bro(cur.getSubmissive(), cur.getDominating(), !cur.isInsideAbove());
			
			if (polySearchWrapper.find(bro,found)){
				loc=static_cast<long>(found);
				dvector<hseg2D>::Iterator bi=segs.getIterator(found);
				hseg2D toret=*(bi.get());
// 				cerr << "Brother (" << bro <<  ") found at: " << found <<  ":::" << toret << endl;
				return toret;
			}
			else{
				loc=-1;
				return hseg2D(); //not found.
			}
		}
		
		hseg2D findNextInChain(dvector<hseg2D> segs, const hseg2D& cur, long& loc)
		{ //finds the next one in chain. deals with polygons connected by articulation points
			
 			//cerr << "Find next of : " << cur << endl;
			long found;
			long offset;
			
			hseg2D bro=findBrother(segs,cur,found);

			dvector<hseg2D>::Iterator fwd=segs.getIterator(found);
			dvector<hseg2D>::Iterator bck=segs.getIterator(found);
				
			hseg2D *b=NULL;
			hseg2D *f=NULL;
			
			b=NULL;
			offset++;
			if (bck.prev()){
				b=bck.get();
				if (b->getDominating()==cur.getSubmissive()){
					loc=found-1;
					return *b;
				}
			}

			offset=0;
			hseg2D * prev=NULL;
			while (true){
				offset++;
				if (fwd.next()){
					prev=f;
					f=fwd.get();
					//cerr << "Current f: " << *f << endl;
					if (f->getDominating()==cur.getSubmissive()){ //then we need to add to list
						prev=f;
					}else{
						if (prev==NULL) throw runtime_error("Should have found next here(1)!");
						loc=found+offset-1;
						return *prev;	
					}
				}else
				{
					if (prev==NULL) throw runtime_error("Should have found next here(2)!");
					loc=found+offset-1;
					return *prev;
				}
			}
		}
		
		void buildRegion(dvector<hseg2D> segs, region2D& reg)
		{
			bool skip=false;
			
			if (skip){
				poly2D p=reg.addFace().addOuterCycle();
				
				dvector<hseg2D>::Iterator myit=segs.getIterator();
				hseg2D * t;

				while (myit.next()){
					t=myit.get();
					p.addhseg(*t);
				}

// 				cout << "Added Poly: " << p << endl;

				return;
			}
			
			vector<face2D*> facelist;
/*			vector<mbb2D*> mbbfaces;*/
			vector<poly2D*> holelist;
/*			vector<mbb2D*> mbbholes;*/
			dvector<hseg2D> segcopy; //at the end of poly building, it contains all outer segs and the first seg of each hole
			
			vector<int> owners(segs.size(),0); //assume to begin that all hsegs have no owner
			
			dvector<hseg2D>::Iterator myit=segs.getIterator();
/*			hseg2D * t;*/
				
			while (myit.next())
				segcopy.push_back(*(myit.get())); //copy segs
			
			/*			cout << "The Segs: " << segs << endl;*/
			
			/*			poly2D p=reg.addFace().addOuterCycle();*/
			//all elements in segs are hsegs, all orphans.
			while (segs.size()>0)
			{
				
				dvector<hseg2D>::Iterator myit=segs.getIterator();
				hseg2D * t;
				
				if (myit.next())
					t=myit.get(); //get current leftMost hseg
					
				//decide whether new poly is outercycle or not depending on current leftmost hseg
				dvector<hseg2D> newpoly;
								
				vector<poiSeg> pointsvisited;
				bool isOuter=t->isInsideAbove();
// 				poly2D *p=new poly2D(t->isInsideAbove()); //container for new poly

				hseg2D first=*t;
				hseg2D current=first;
				hseg2D next=first;
				long loc=0;

				do
				{

/*					setMBB(current,minx,miny,maxx,maxy,firstseg);*/
					//cerr << "Current sequences of result segs: " << segs << endl;
					newpoly.push_back(current);
					
// 					p->addhseg(current);	
// 					p->addhseg(hseg2D(current.getSubmissive(), current.getDominating(), !current.isInsideAbove()));	

//   					cerr << "Added hseg: " << current << endl;

					next=findNextInChain(segs,current,loc);
/*					cout << "Before: " << segs << endl;*/
					
					vectorBinarySearchWrapper< dvector<hseg2D>, hseg2D > segfinder( &segcopy );
					
					uint segfound, segfoundbro;
					bool copyfound, copyfoundbro;
					
					copyfound=segfinder.find(next,segfound);
					copyfoundbro=segfinder.find(hseg2D(next.getSubmissive(), next.getDominating(),!next.isInsideAbove()),segfoundbro);
						
					//cerr << "Found copy of: " << next << endl;
						
// 					if (!isOuter && next!=first) //remove all but the first hseg of each hole
// 					{
// 						if (copyfound)
// 						{
// 							segcopy.erase(segfound);
// 							vector<int>::iterator oitr=owners.begin();
// 							oitr+=segfound;
// 							owners.erase(oitr);
// 						}
// 						else
// 							throw runtime_error("Should have been found at copy1.");
// 						
// 						if (copyfoundbro)
// 						{
// 							segcopy.erase(segfoundbro);
// 							vector<int>::iterator oitr=owners.begin();
// 							oitr+=segfoundbro;
// 							owners.erase(oitr);
// 						}
// 						else
// 							throw runtime_error("Should have been found at copy2.");
// 						
// 					}else{ 
					
					//annotate owner of next
					//if (!isOuter) cerr << "Will annotate first element of this hole!!!" << endl;
					if (copyfound)
					{
						if (isOuter)
							owners[segfound]=(facelist.size()+1);
						else
							owners[segfound]=((holelist.size()+1)*-1);
						
						//cerr << "Annotated " << segfound << " with " << owners[segfound] << endl;
					}
					else
						throw runtime_error("Should have been found at copy3.");
					
					if (copyfoundbro)
					{
						if (isOuter)
							owners[segfoundbro]=(facelist.size()+1);
						else
							owners[segfoundbro]=((holelist.size()+1)*-1);
						//cerr << "Annotated brother " << segfoundbro << " with " << owners[segfoundbro] << endl;
					}
					else
						throw runtime_error("Should have been found at copy4.");
					//no need to annotate right brother
/*					}*/
						
					//erase the next before its added
					segs.erase(loc);
								
// 					cout << "After: " << segs << endl;
// 						
// 					cout << "Erased: " << next << endl;
					
					hseg2D bro=findBrother(segs,current,loc);
					if ( loc>-1 )
					{
						//erase current's brother
						segs.erase(loc);
					}
					
					vectorBinarySearchWrapper< vector<poiSeg>, poiSeg > poifinder( &pointsvisited );
					uint poifound;
					poiSeg temppseg;
					temppseg.p=next.getDominating();
					temppseg.loc=newpoly.size();
					
					if (poifinder.find(temppseg,poifound))
					{
						
/*						cerr << "Found point: " << temppseg.p << endl;*/
						
						if (first==next)
							break; //stop here, cause this closes a cycle. the pseudo hole will be found later
						
						poly2D *hole=new poly2D(false);
						
						poiSeg tempseg=pointsvisited[poifound];
						for (uint i=tempseg.loc; i<newpoly.size(); i++)
						{
/*							setMBB(newpoly[i],hminx,hminy,hmaxx,hmaxy,hfirstseg);*/
							
/*							cout << "Adding HOLE hseg: " << newpoly[i]<< endl;*/
							vectorBinarySearchWrapper< dvector<hseg2D>, hseg2D > segfinder( &segcopy );
							uint segfound;
						
							bool foundit=segfinder.find(newpoly[i],segfound);

/*							if (i==tempseg.loc) //remove all hole segments but the first
							{*/
								owners[segfound]=((holelist.size()+1)*-1);
								hseg2D segbro(hseg2D(newpoly[i].getSubmissive(), newpoly[i].getDominating(), !newpoly[i].isInsideAbove()));
								foundit=segfinder.find(segbro,segfound);
								if (foundit)
								{
									owners[segfound]=((holelist.size()+1)*-1);
								}else throw runtime_error("Should have found it here(3).");
								//cout << "Assigned element as a hole. " << endl;
/*							}*/
// 							else
// 							{
// 								//remove it. and its brother
// 								if (foundit)
// 								{
// 									segcopy.erase(segfound);
// 									vector<int>::iterator oitr=owners.begin();
// 									oitr+=segfound;
// 									owners.erase(oitr);
// 								}else throw runtime_error("Should have found it here(4).");
// 								//remove brother
// 								hseg2D segbro(hseg2D(newpoly[i].getSubmissive(), newpoly[i].getDominating(), !newpoly[i].isInsideAbove()));
// 								foundit=segfinder.find(segbro,segfound);
// 								if (foundit)
// 								{
// 									segcopy.erase(segfound);
// 									vector<int>::iterator oitr=owners.begin();
// 									oitr+=segfound;
// 									owners.erase(oitr);
// 								}else throw runtime_error("Should have found it here(5).");
// 							}
									
							hole->addhseg(newpoly[i]);
							hole->addhseg(hseg2D(newpoly[i].getSubmissive(), newpoly[i].getDominating(), !newpoly[i].isInsideAbove()));
							
						}
						for (int i=newpoly.size()-1; i>=tempseg.loc; i--)
						{
/*							cerr << "Removing: " << newpoly[i] << endl;*/
							newpoly.erase(i);
						}
						
						if (!hole->validate()) //validate the polygon
							cerr << "The hole is invalid!!" << endl;
/*						mbb2D *r =new mbb2D(poi2D(hminx,hminy),poi2D(hmaxx,hmaxy));*/
						holelist.push_back(hole);
						//cout << "Added Hole(2): " << *hole << endl;
						/*						mbbholes.push_back(r);*/
					}
					else
					{
						vector<poiSeg>::iterator pitr=pointsvisited.begin();
						pointsvisited.insert(pitr+poifound,temppseg);
					}
					
					current=next;
				}while (first!=next);

// 				hseg2D bro=findBrother(segs,first,loc);
 				//segs.erase(0); //remove first of this polygon, left there so that it could be found!
// 				if ( loc>-1 ) segs.erase(loc); //and its brother

				poly2D *p=new poly2D(isOuter);
				for (uint i=0; i<newpoly.size(); i++)
				{
					p->addhseg(newpoly[i]);
					p->addhseg(hseg2D(newpoly[i].getSubmissive(), newpoly[i].getDominating(), !newpoly[i].isInsideAbove()));
				}
				
				if (!p->validate()) //validate the polygon
					cerr << "Polygon did not validate: " << *p << endl;
/*				mbb2D *r =new mbb2D(poi2D(minx,miny),poi2D(maxx,maxy));*/
				
				if (p->isOuterCycle())
				{
					face2D *temp=new face2D();
					temp->addOuterCycle(*p);
					facelist.push_back(temp);
					delete p;
/*					mbbfaces.push_back(r);*/
/*					cout << "Added Outer: " << *p << endl;*/
				}
				else
				{
					holelist.push_back(p);
/*					mbbholes.push_back(r);*/
					//cout << "Added Hole: " << *p << endl;
				}
			}
			//done building polygons, now build region
			
			whichObj object;
			whatStatus status;
			dvector<hseg2D> dyn1;
			dvector<hseg2D> dyn2;
			dvector<hseg2D> tempPl;
			EventSchedule<dvector<hseg2D>, dvector<hseg2D>, hseg2D, hseg2D> eventSched( segcopy, tempPl, dyn1, dyn2 );
			SweepLine<dvector<hseg2D>, dvector<hseg2D>, hseg2D, hseg2D> S( true );
			vectorBinarySearchWrapper< dvector<hseg2D>, hseg2D > segfinder( &segcopy ); 
			statusHseg2D sh;
			eventSched.select_first(object, status);
			hseg2D segCurr, segAbove, segBelow;
			bool aboveExists, belowExists;
			uint currfound;
			uint belowfound;
			vector<int> holeassign(holelist.size(),-1);	
			for (int i=0; i<holeassign.size(); i++)
				holeassign[i]=-1;
			
			while(status != end_of_both )
			{
						//cout << "Looking" << endl;
				if(object == first || object == both )
				{
					sh = statusHseg2D(*(eventSched.i1), 'F');
					if(eventSched.i1->isLeft())
					{
						S.add_left_Return_Segs( sh, eventSched, segCurr, segAbove, aboveExists, segBelow, belowExists );
						
						if (!segfinder.find(segCurr,currfound))
							throw runtime_error("Gosh, should have!");
						
/* 						cerr << "Looking at: " << *(eventSched.i1) << " Owner: " << owners[currfound]<<endl;*/
						if (owners[currfound]<0) //then its a hole, care about it
						{
/*							cerr << "Hole seg owned by face: " << holeassign[((owners[currfound]*-1)-1)]<< endl;*/
							if (holeassign[((owners[currfound]*-1)-1)]<0)
							{
								if (belowExists)
								{
									if (segfinder.find(segBelow,belowfound))
									{
										if (owners[belowfound]>0) //then assign this hole to this face
										{
/*											cerr << "Owner face: " << owners[belowfound]-1 << " Number of faces: " << facelist.size() << endl;
											cerr << "Owner Hole: " << ((owners[currfound]*-1)-1) <<  " Number of holes: " << holelist.size() << endl;*/
											//cerr << "HOLE: " << *holelist[((owners[currfound]*-1)-1)] << endl;
											
											facelist[owners[belowfound]-1]->addHole(*holelist[((owners[currfound]*-1)-1)]);
/*											facelist[owners[belowfound]-1]->validate();*/
											holeassign[((owners[currfound]*-1)-1)]=owners[belowfound]-1;
	// 										delete holelist[((owners[currfound]*-1)-1)];
	/*										statusHseg2D shbro = statusHseg2D(hseg2D(segCurr.getSubmissive(), segCurr.getDominating(), !segCurr.isInsideAbove()), 'F');
											S.del_right(shbro, eventSched);*/
											//cerr << "FACE: " << *facelist[owners[belowfound]-1] << endl;
										}else if (owners[belowfound]<0) //then assign this hole to the found hole's face (they are brothers)
										{
											if (holeassign[((owners[belowfound]*-1)-1)]<0)
												throw runtime_error("This hole should have been already assigned");
											
											facelist[holeassign[((owners[belowfound]*-1)-1)]]->addHole(*holelist[((owners[currfound]*-1)-1)]);
/*											facelist[holeassign[((owners[belowfound]*-1)-1)]]->validate();*/
											holeassign[((owners[currfound]*-1)-1)]=holeassign[((owners[belowfound]*-1)-1)];
											
											
/*											cerr << "Owner face through hole: " << ((owners[belowfound]*-1)-1) << " Assigned: " << holeassign[((owners[belowfound]*-1)-1)] << endl;
											cerr << "Owner Hole: " << ((owners[currfound]*-1)-1) <<  endl;*/
										}	
									}
									else
										throw runtime_error("Gosh, should have!");
								}else
									cerr <<"But no below exists!" << endl;
							}
						}
					}
					else
					{
						S.del_right(sh, eventSched);
					}
				}
				eventSched.select_next(object, status);
			}
			
			for (uint i=0; i<facelist.size(); i++)
			{
				if (!facelist[i]->validate())
					cerr << "Could not validate face: " << *(facelist[i]) << endl;
				reg.addFace(*(facelist[i]));
				delete facelist[i];
			}
			
			reg.validate();
		}
		
		region2D region2D::intersection(const region2D &other) const throw (runtime_error)
		{
			if (!(this->isValid() && other.isValid()))
				throw runtime_error("Cannot compute intersection of invalid region.");
			dvector<hseg2D> result;
			Algorithm_rr algo;
			algo.operate(*const_cast<region2D*>(this),*const_cast<region2D*>(&other),INTERSECTION,result);
		
			region2D toret;
			buildRegion(result,toret);
		
			return toret;
		}
		
		region2D region2D::sunion(const region2D &other) const
		{
			if (!(this->isValid() && other.isValid()))
				throw runtime_error("Cannot compute union of invalid region.");
			dvector<hseg2D> result;
			Algorithm_rr algo;
			algo.operate(*const_cast<region2D*>(this),*const_cast<region2D*>(&other),UNION,result);
		
			region2D toret;
			buildRegion(result,toret);
		
			return toret;
		}
		
		region2D region2D::difference(const region2D &other) const
		{
			if (!(this->isValid() && other.isValid()))
				throw runtime_error("Cannot compute difference of invalid region.");
			dvector<hseg2D> result;
			Algorithm_rr algo;
			algo.operate(*const_cast<region2D*>(this),*const_cast<region2D*>(&other),DIFFERENCE,result);
			
			region2D toret;
			buildRegion(result,toret);
		
			return toret;
		}
	

	
		line2D region2D::delaunayTriangulation()
		{
			cout<<"region2D::delaunay"<<endl;
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.triangulation(m_poi_set, reg);
			return reg;
		}

				
	
		line2D region2D::voronoi()
		{
			cout<<"region2D::voronoi"<<endl;
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			line2D reg;
			CDelaunay del;	
			del.voronoi(m_poi_set, reg);
			return reg;
		}

		region2D region2D::convexHull()
		{
			
			vector<poi2D> m_poi_set;
			getAllDominates(m_poi_set);
			region2D reg;
			CConvexHull hull;
			hull.getConvexHull(m_poi_set, reg);
			return reg;
		}
		
	
		
		void region2D::getAllDominates(vector<poi2D>& m_poi_set) 
		{
	
			region2D::Iterator lj=getIterator();
			bool first= true;
			
			while(lj.next())
			{
				hseg2D *tj=lj.get();
				poi2D poi=tj->getDominating();
				if(first){
					m_poi_set.push_back(poi);
					first = false;
				}else{
					/* to compare the last element */
					if(m_poi_set.back()!= poi)
						m_poi_set.push_back(poi);	
				}
			}

		}

		
		
		std::ostream& operator << (std::ostream &ostr, const region2D &rhs) throw( undefinedSpatialObjectException )
		{
			if( !rhs.isValid( ) ) {
				ostr<< "--(Invalid Region)--" ;
			} 
			//cout << "There are " << rhs.elements.count() << " pois in this point" << endl;
			region2D::Iterator p1=rhs.getIterator();
			hseg2D* pp1;
			ostr << rhs.getSegmentCount() << " segments-> ";
			ostr << "[";
			while (p1.next()){
				pp1=p1.get();
				ostr << ", " << *pp1;
			}
			ostr << "]";
			return ostr;
		}


	

}


