#ifndef STATUSHSEG2D_H
#define STATUSHSEG2D_H

#include "hseg2D.h"
#include <stdlib.h>
#include <stdio.h>
//#include "SweepLine.h"
/** This class is used for Plane Sweep Algorithms
 *  \author Reasey Praing
 *  \version 0.1
 *  \date    2006-10-25
 */

namespace stu
{
using namespace stu;

class statusHseg2D
{
	public:
		hseg2D *hseg;
		char owner;
		int m, n; //Overlap Numbers
		int data; //used to store any extra info that might be necessary
		//static rat vertical = 0;
		statusHseg2D()
		{
			//hseg = hseg2D();
			owner = '_';	//not specified
			m = 0;
			n = 1;
			data=-1;
		}
		statusHseg2D(unsigned char *buffer, uint len) //deserializes byte stream in buffer into hseg2D
		{
			owner = *((char*)buffer);
			//unsigned char* temp = buffer[sizeof(int)];
			//char cn[1]; cn[0] = buffer[2*sizeof(char)];
			m = *((int*)(buffer+sizeof(char)));
			n = *((int*)(buffer+sizeof(char)+sizeof(int)));
			data = *((int*)(buffer+sizeof(char)+sizeof(int)+sizeof(int)));
			//cout<<"[Deserialized m n data: "<< m << " " << n << " " << data <<"]"; 
			hseg = new hseg2D(buffer+sizeof(char)+sizeof(int)+sizeof(int)+sizeof(int), len-sizeof(char)-sizeof(int)-sizeof(int)-sizeof(int));
		}
		statusHseg2D(hseg2D hs, char o) : owner(o)
		{
			hseg = new hseg2D(hs);
			if(hseg->isLeft())
				if(hseg->isInsideAbove())
				{
					m = 0;
					n = 1;
				}
				else
				{
					m = 1;
					n = 0;
				}
			data=-1;
		}
		statusHseg2D& operator = (const statusHseg2D &rhs) throw( undefinedSpatialObjectException )
		{
			if (rhs.hseg->isEmpty()) throw undefinedSpatialObjectException();
			hseg = new hseg2D();
			*hseg = *(rhs.hseg);
			owner = rhs.owner;
			m = rhs.m;
			n = rhs.n;
			return *this;
		}
		bool operator == (const statusHseg2D &rhs) const
		{
			return (hseg->getSegment() == rhs.hseg->getSegment()); //Only consider the segments
		}
		bool operator < (const statusHseg2D &h) const  
		{
			//IMPORTANT: The comparator uses the x-coordinate of the dominating point of the current statusHseg2D as the vertical sweepline to define the order.
			rat x = hseg->getDominating().getX();
			rat result(-1.0);
			rat slope = rat(0);
			rat b(0.0);
			if(h.hseg->getDominating().getX() == x || (h.hseg->getSubmissive().getX() - h.hseg->getDominating().getX() == 0))
			{
				if(*(hseg) < *(h.hseg))
					return true;
				else
					return false; 
			}
			else
			{
				rat y2 = h.hseg->getSubmissive().getY();
				rat y1 = h.hseg->getDominating().getY();
				rat x2 = h.hseg->getSubmissive().getX();
				rat x1 = h.hseg->getDominating().getX();
				rat n = y2 - y1;
				rat d = x2 - x1;
				slope = n/d;
				b = h.hseg->getSubmissive().getY() - slope * h.hseg->getSubmissive().getX();
				result = slope * x + b;
			}

			return (hseg->getDominating().getY() < result);
		}
		//serialization
		uint serialize(unsigned char *buffer) const
		{
			unsigned char *buf, *buf1, *buf2, *buf3;
			buf = (unsigned char*)&owner;
			for (uint j=0; j<sizeof(char); j++)
				buffer[j]=buf[j];
			buf1 = (unsigned char*)&m;
			for (uint j=0; j<sizeof(int); j++)
				buffer[sizeof(char)+j]=buf1[j];
			buf2 = (unsigned char*)&n;
			for (uint j=0; j<sizeof(int); j++)
				buffer[sizeof(char)+sizeof(int)+j]=buf2[j];
			buf3 = (unsigned char*)&data;
			for (uint j=0; j<sizeof(int); j++)
				buffer[sizeof(char)+sizeof(int)+sizeof(int)+j]=buf3[j];
			//cout<<"[Serialized m n data: "<< m << " " << n << " " << data <<"]"; 
			//store owner, m, and n
			//data[0] = owner;
			//char cm[1], cn[1];
			//sprintf(cm, "%d", m);
			//sprintf(cn, "%d", n);
			
			//cout<<"Serialize: "<<m<<" "<<n<<endl;
			//data[sizeof(char)] = cm[0];
			//data[sizeof(char)*2] = cn[0];
			
			//then store hseg
			uint hseglen=hseg->serialize(buffer+sizeof(char)+sizeof(int)+sizeof(int)+sizeof(int));
		
			return hseglen+sizeof(char)+sizeof(int)+sizeof(int)+sizeof(int);
		}
		uint serialSize() const //returns the size of bytes used by this object when serialized
		{
			return sizeof(char)+sizeof(int)+sizeof(int)+sizeof(int)+hseg->serialSize();
		}
		friend std::ostream& operator << (std::ostream &ostr, const statusHseg2D &rhs)
		{
			ostr << "(" << *(rhs.hseg) << "," << rhs.owner << "," << rhs.m<< "," << rhs.n<< ")";
			return ostr;
		}
		void print()
		{
			cout << " Owner: " << owner << " OverlapNum: " << m << "/" << n << "\n";
		}
};
}
#endif
