#ifndef BUTTON_H
#define BUTTON_H

#include <gl.h>
#include <glut.h>
#include <string>

#define DEFAULT_WIDTH 100
#define DEFAULT_HEIGHT 5
using namespace std;

class button
{
	private:
		bool selected;
		uint width;
		uint height;
		uint xPos;
		uint yPos;
		string title;
		uint code;
		
	public:
		
		button(): selected( false ), width( 0 ), height( 0 ), xPos( 0 ), yPos( 0 ), title( "" ), code( 0 )
		{	}
		button( string buttonTitle, uint x, uint y, uint w, uint h, uint buttonCode ): selected( false ), width( w ), height( h ), xPos( x ), yPos( y ), title( buttonTitle ), code( buttonCode )
		{	}
		
		uint getCode( )
		{ return code; }
		
		void set( string buttonTitle, uint x, uint y, uint w, uint h, uint buttonCode )
		{
			selected = false;
			xPos = x;
			yPos = y;
			width = w;
			height = h;
			title.assign( buttonTitle );
			code = buttonCode;
		}
		
		bool clicked( float xx, float yy )
		{
			bool inButton = false;
			if( xx > xPos && xx < xPos+width && yy < yPos && yy > yPos - height )
				inButton = true;
			return inButton;
		}
		
		bool isSelected( )
		{
			return selected;
		}
		void select( )
		{
			selected = true;
		}
		
		void select( bool val )
		{
			selected = val;
		}
		
		void display( )
		{
			//daw the button's rectangle
			if( selected )
				glColor3f( .7f, .7f, .7f );
			else
				glColor3f( .9f, .9f, .9f );
			glBegin( GL_POLYGON );
				glVertex2f( xPos, yPos);
				glVertex2f (xPos + width, yPos);
				glVertex2f (xPos + width, yPos - height);
				glVertex2f (xPos, yPos - height);
			glEnd();
			
			//draw the button's text
			glColor3f(0.0f, 0.0f, 0.0f);
			bitmap_output(xPos +5 , yPos - 3 , const_cast<char*>( title.c_str() ), GLUT_BITMAP_HELVETICA_10);
			
			//draw the button's outline
			glColor3f (0.0F, 0.0F, 0.0F);
			glBegin (GL_LINE_LOOP);
				glVertex2f( xPos, yPos-.1);
				glVertex2f (xPos + width-.1, yPos-.1);
				glVertex2f (xPos + width-.1, yPos - height);
				glVertex2f (xPos, yPos - height);
			glEnd ();
			
		}
		
		//draws text on the screen
		void bitmap_output(int x, int y, char *string, void *font)
		{  
			int len, i;
			glRasterPos3f(x, y, 0);            // Locate Raster Position in 3-space
			len = (int) strlen(string);        // Find length of string
			for (i = 0; i < len; i++)
			{
		// Loop through plotting all characters in font style
				glutBitmapCharacter(font, string[i]);
			}
		}
		
		button & operator = ( button & rhs )
		{
			selected = rhs.selected;
			xPos = rhs.xPos;
			yPos = rhs.yPos;
			width = rhs.width;
			height = rhs.height;
			title.assign( rhs.title );
			code = rhs.code;
			return *this;
		}
};



#endif

